#include "hmg.ch"
&& # include "hfcl.ch"

declare window interest

function depositinitial
local intarr2 := {360,12,4,2,1}
local initial := 0.0
local maturity := interest.depositmaturity.value
local intrate := interest.depositinterest.value / 100
local period := interest.depositperiod.value
local yearlycompoundings := intarr2[interest.depositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.depositinterval.value] // No. of instalements per annum
local m := 0.0
if maturity == 0.0 .or. intrate == 0.0 .or. period == 0.0
   msginfo("You have to enter all the other values.!","Interest Rate Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   initial := maturity
   initial := initial / (1+(m * balacomp))
   initial := initial / ((1+(intrate / yearlycompoundings))^fulcomp)
   interest.initialdeposit.value := initial
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings
   initial := maturity / ((1+m)^(period / yearlyinstalments * yearlycompoundings))
   interest.initialdeposit.value := initial
endif
showfixeddepositaccount()
return nil

function depositintrate
local intarr2 := {360,12,4,2,1}
local initial := interest.initialdeposit.value
local maturity := interest.depositmaturity.value
local intrate := 0.0
local period := interest.depositperiod.value
local yearlycompoundings := intarr2[interest.depositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.depositinterval.value] // No. of instalements per annum
local m := 0.0
if maturity == 0.0 .or. initial == 0.0 .or. period == 0.0
   msginfo("You have to enter all the other values!","Interest Rate Calculator")
   return nil
endif
if maturity <= initial
   msginfo("Maturity amount MUST be greater than the amount invested.","Interest Rate Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   if fulcomp > 0
      m := ((maturity / initial) ^ (1 / fulcomp)) - 1
      intrate := m * yearlycompoundings
      if balacomp > 0
         crossed := .f.
         do while .not. crossed
            m := intrate / yearlyinstalments
            if (initial * (1+(intrate / yearlycompoundings))^fulcomp) * (1+(m * balacomp)) <= maturity
               crossed := .t.
            else
               intrate := intrate - 0.000001
            endif
         enddo
      endif
   else
      if balacomp > 0
         intrate := 0.000001
         crossed := .f.
         do while .not. crossed
            m := intrate / yearlyinstalments
            if (initial * (1+(m * balacomp))) >= maturity
               crossed := .t.
            else
               intrate := intrate + 0.000001
            endif
         enddo
      endif
   endif
   interest.depositinterest.value := intrate * 100
endif
if yearlyinstalments < yearlycompoundings
   x := (period / yearlyinstalments * yearlycompoundings)
   m := ((maturity/initial) ^ (1/x)) - 1
   interest.depositinterest.value := m * yearlycompoundings * 100
endif
showfixeddepositaccount()
return nil

function depositperiod
local intarr2 := {360,12,4,2,1}
local initial := interest.initialdeposit.value
local intrate := interest.depositinterest.value / 100
local maturity := interest.depositmaturity.value
local period := interest.depositperiod.value
local yearlycompoundings := intarr2[interest.depositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.depositinterval.value] // No. of instalements per annum
local m := 0.0
if initial == 0.0 .or. intrate == 0.0 .or. maturity == 0.0
   msginfo("You have to enter all the other values!","Interest Rate Calculator")
   return nil
endif
if maturity <= initial
   msginfo("Maturity amount MUST be greater than the amount invested.","Interest Rate Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlycompoundings// rate per yearlyinstalments
   x := (log(maturity) - log(initial)) / log((1+m))
   period := int(x) / yearlycompoundings * yearlyinstalments
   if x - int(x) > 0.0
      maturity1 := (initial * (1+(intrate / yearlycompoundings))^int(x))
      n := ((maturity/maturity1) - 1) /(intrate / yearlyinstalments)
      period := period + n
   endif
   interest.depositperiod.value := int(period)
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings
   x := (log(maturity) - log(initial)) / log((1+m))
   period := x / yearlycompoundings * yearlyinstalments
   interest.depositperiod.value := int(period)
endif
showfixeddepositaccount()
return nil

function depmaturity
local intarr2 := {360,12,4,2,1}
local initial := interest.initialdeposit.value
local intrate := interest.depositinterest.value / 100
local period := interest.depositperiod.value
local yearlycompoundings := intarr2[interest.depositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.depositinterval.value] // No. of instalements per annum
local m := 0.0
if initial == 0.0 .or. intrate == 0.0 .or. period == 0.0
   msginfo("You have to enter all the other values!","Interest Rate Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   maturity := (initial * (1+(intrate / yearlycompoundings))^fulcomp) * (1+(m * balacomp))
   interest.depositmaturity.value := maturity
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings
   maturity := initial * (1+m)^(period / yearlyinstalments * yearlycompoundings)
   interest.depositmaturity.value := maturity
endif
showfixeddepositaccount()
return nil


function showfixeddepositaccount
local intarr2 := {360,12,4,2,1}
local initial := interest.initialdeposit.value
local intrate := interest.depositinterest.value / 100
local period := interest.depositperiod.value
local maturity := interest.depositmaturity.value
local yearlycompoundings := intarr2[interest.depositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.depositinterval.value] // No. of instalements per annum
local reportarr := {}
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   set conso off
   set alter to fdrrep
   set alter on
   head1 := interest.depositinterval.item(interest.depositinterval.value)
   counter := 1
   count1 := 1
   balance := initial
   totint := 0
   totinst := 0
   product := 0
   interest := 0
   ?"Initial Amount      :"+str(balance,16,2)
   ?"Period of Investment :"+str(period,3,0)+" "+interest.depositinterval.item(interest.depositinterval.value)
   ?"Amount of Maturity  :"+str(maturity,14,2)
   ?"Interest Compounding  :"+" "+alltrim(interest.depositintcomp.item(interest.depositintcomp.value))
   ?"Interest Rate         :"+str(interest.depositinterest.value,6,2)+" % p.a."
   ?"-----------------------------------------------------------------"
   ?head1 + space(10 - len(head1))+"   Op. Balance   +     Interest      =    Cl. Balance. "
   ?"-----------------------------------------------------------------"
   do while counter <= period
      product := product + balance
      if mod(counter,yearlyinstalments/yearlycompoundings) == 0
         interest := round(product * m,2)
         totint := interest + totint
         product := 0.0
      endif
      if counter > (fulcomp / yearlycompoundings * yearlyinstalments)
         product := 0
         do while count1 <= balacomp
            product := product + balance
            if counter == period
               interest := round(product * m,2)
               totint := interest + totint
               product := 0
            endif
            if interest > 0.0
               ? str(counter,5,0)+"   "+str(balance,14,2)+"     +   "+str(interest,10,2)
               aadd(reportarr,{counter,balance,interest,balance + interest})
               balance := balance + interest
               ??"      ="+str(balance,12,2)
            endif
            count1 := count1 + 1
            counter := counter + 1
            interest := 0.0
         enddo
      endif
      if counter <= (fulcomp / yearlycompoundings * yearlyinstalments)
         if interest > 0.0
            ? str(counter,5,0)+"   "+str(balance,14,2)+"     +   "+str(interest,10,2)
            aadd(reportarr,{counter,balance,interest,balance + interest})
            balance := balance + interest
            ??"      ="+str(balance,12,2)
         endif
         counter := counter + 1
         interest := 0.0
      endif
   enddo
   ?"-----------------------------------------------------------------"
   ?"              Total            "+str(totint,10,2)
   ?"-----------------------------------------------------------------"
   set alte off
   set alte to
   set conso on
   interest.fixeddepositaccount.deleteallitems()
   interest.fixeddepositaccount.header(1) := head1
   for i := 1 to len(reportarr)
      interest.fixeddepositaccount.additem({alltrim(str(reportarr[i,1],5,0)),;
                                    alltrim(iif(reportarr[i,2] > 0,str(reportarr[i,2],14,2),"")),;
                                    alltrim(iif(reportarr[i,3] > 0,str(reportarr[i,3],14,2),"")),;
                                    alltrim(str(reportarr[i,4],14,2))})
   next i
   interest.fixeddepositaccount.value := 1
   interest.fdtotalinterest.value := totint
   interest.fixeddepositaccount.setFocus()
   fdreportcreated := .t.
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings  // rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   set conso off
   set alter to fdrrep
   set alter on
   head1 := interest.depositinterval.item(interest.depositintcomp.value)
   counter := 1
   count1 := 1
   instal1 := 0.0
   balance := initial
   totint := 0.0
   totinst := 0.0
   product := 0.0
   interest := 0.0
   ?"Initial Amount      :"+str(balance,16,2)
   ?"Period of Investment :"+str(period,3,0)+" "+interest.depositinterval.item(interest.depositinterval.value)
   ?"Amount of Maturity  :"+str(maturity,14,2)
   ?"Interest Compounding  :"+" "+alltrim(interest.depositintcomp.item(interest.depositintcomp.value))
   ?"Interest Rate         :"+str(interest.depositinterest.value,6,2)+" % p.a."
   ?"-----------------------------------------------------------------"
   ?head1 + space(10 - len(head1))+"   Op. Balance   +     Interest      =    Cl. Balance. "
   ?"-----------------------------------------------------------------"
   comcount := 1
   do while counter <= period * yearlycompoundings/yearlyinstalments
      product := balance + product
      interest := round(product * m,2)
      totint := totint + interest
      product := 0.0
      if interest > 0.0
         ? str(counter,5,0)+"   "+str(balance,14,2)+"     +   "+str(interest,10,2)
         aadd(reportarr,{counter,balance,interest,balance + interest})
         balance := balance + interest
         ??"      ="+str(balance,12,2)
      endif
      counter := counter + 1
      interest := 0.0
   enddo
   ?"-----------------------------------------------------------------"
   ?"              Total            "+str(totint,10,2)
   ?"-----------------------------------------------------------------"
   set alte off
   set alte to
   set conso on
   interest.fixeddepositaccount.deleteallitems()
   interest.fixeddepositaccount.header(1) := head1
   for i := 1 to len(reportarr)
      interest.fixeddepositaccount.additem({alltrim(str(reportarr[i,1],5,0)),;
                                    alltrim(iif(reportarr[i,2] > 0,str(reportarr[i,2],14,2),"")),;
                                    alltrim(iif(reportarr[i,3] > 0,str(reportarr[i,3],14,2),"")),;
                                    alltrim(str(reportarr[i,4],14,2))})
   next i
   interest.fixeddepositaccount.value := 1
   interest.fdtotalinterest.value := totint
   interest.fixeddepositaccount.setFocus()
   fdreportcreated := .t.
endif
return nil

function fixeddeposittextreport
if .not. fdreportcreated
   msginfo("No reports created so far.","Interest Rate Calculator")
   return nil
endif
showtext("fdrrep.txt")
return nil

function fdrepprint
&& local aHeaders := {"Deposit Amount: "+alltrim(str(interest.initialdeposit.value))+","+"Interest Rate: "+alltrim(str(interest.depositinterest.value))+"% ("+alltrim(interest.depositintcomp.item(interest.depositintcomp.value))+" Compunding)",;
                    && "Period :"+alltrim(str(interest.depositperiod.value))+" "+alltrim(interest.depositinterval.item(interest.depositinterval.value))+" Maturity Value: "+alltrim(str(interest.depositmaturity.value))}

&& print grid fixeddepositaccount of interest headers aHeaders columnsum {{.f.,""},{.f.,""},{.t.,"99999999999.99"},{.f.,""}}
return nil


function fdexportxl
local oExcel, oH
local reportarr := {}
local row := 5
if interest.fixeddepositaccount.itemcount == 0
   msgstop("Nothing to export!","Error")
   return nil
endif
oExcel := TOleAuto():new( "Excel.Application" )
if Ole2TxtError() != "S_OK"
   MsgStop("Excel Not available.", "Error")
   return nil
endif
oExcel:WorkBooks:add()
oH := oExcel:Get( "ActiveSheet" )
oH:cells(row,1):value := "Initial Amount :"
oH:cells(row,2):value := interest.initialdeposit.value  &&b5
row := row + 1
oH:cells(row,1):value := "Period of Investment :"
oH:cells(row,2):value := interest.depositperiod.value
oH:cells(row,3):value := interest.depositinterval.item(interest.depositinterval.value)
row := row + 1
oH:cells(row,1):value := "Maturity Amount :"
oH:cells(row,2):value := interest.depositmaturity.value
row := row + 1
oH:cells(row,1):value := "Interest Compounding  :"
oH:cells(row,2):value := alltrim(interest.depositintcomp.item(interest.depositintcomp.value))
row := row + 1
oH:cells(row,1):value := "Interest Rate:"
oH:cells(row,2):value := interest.depositinterest.value/100
oH:cells(row,2):set( "NumberFormat", "0.00%" )
oH:cells(row,3):value := "p.a."
row := row + 2
oH:cells(row,1):value := interest.fixeddepositaccount.header(1)
oH:cells(row,2):value := interest.fixeddepositaccount.header(2)
oH:cells(row,3):value := interest.fixeddepositaccount.header(3)
oH:cells(row,4):value := interest.fixeddepositaccount.header(4)
row := row + 1
frow := row
for i := 1 to interest.fixeddepositaccount.itemcount
   if i == 1
      oH:cells(row,1):value := i
      oH:cells(row,2):value := "=b5"
      oH:cells(row,2):set ("NumberFormat","##########0.00")
   else
      oH:cells(row,1):value := i
      oH:cells(row,2):value := "=d"+alltrim(str(row-1,5,0))
      oH:cells(row,2):set ("NumberFormat","##########0.00")
   endif
   templine := interest.fixeddepositaccount.item(i)
   oH:cells(row,3):value := val(alltrim(templine[3]))
   oH:cells(row,3):set ("NumberFormat","##########0.00")
   oH:cells(row,4):value := "=b"+alltrim(str(row,5,0))+"+c"+alltrim(str(row,5,0))
   oH:cells(row,4):set ("NumberFormat","##########0.00")
   row := row + 1
next i
oH:cells(row,3):value := "=sum(c"+alltrim(str(frow,5,0))+":c"+alltrim(str(row-1,5,0))
oH:cells(row,3):set ("NumberFormat","##########0.00")
oH:cells(1,1):select()
oExcel:visible := .T.
oH:end()
oExcel:end()
return nil



