# include "hmg.ch"
# include "common.ch"
&& # include "hfcl.ch"

declare window interest

function yearchange
month := (interest.monthselect.value)
year := (interest.yearselect.value)
stdate := ctod("01"+"/"+alltrim(str(month,2,0))+"/"+alltrim(str(year,4,0)))
enddate := ctod("01"+"/"+alltrim(str(month,2,0))+"/"+alltrim(str(year+1,4,0))) - 1
interest.date1.value := stdate
if len(acarr) > 0
   if acarr[1,1] < stdate .or. acarr[len(acarr),1] > enddate
      msgbox("Warning. The accounts in the input section is not coinciding with this year! You have to change them before calculating interest.")
   endif
endif
return nil

function addintrate
local curline := (interest.interestgrid.itemcount)
stdateval := intratearr[curline,2]+1
enddateval := enddate
intval := intratearr[curline,3]
define window addint at 250,120 width 300 height 200 modal nosysmenu nosize
   @  10, 10 label      stdatelab  value "From"
   @  10,100 datepicker stdate1    value stdateval
   @  40, 10 label      endatelab  value "To"
   @  40,100 datepicker enddate1   value enddateval
   @  70, 10 label      intratelab value "Rate"
   @  70,100 textbox    intrate    value (intval * 100) width 50 numeric inputmask "99.99" rightalign
   @  70,160 label      per        value "%"
   @ 110, 20 button     ok1        caption "Ok" action okclick()
   @ 110,130 button     cancel1    caption "Cancel" action cancelclick()
end window
addint.stdate1.enabled := .f.
activate window addint
return nil

function delintrate
local curline := (interest.interestgrid.value)
if curline > 0
   if (interest.interestgrid.itemcount) > 1
      length := len(intratearr)
      enddateval := intratearr[curline,2]
      intratearr[curline - 1,2] := enddateval
      interest.interestgrid.item(curline - 1) := {dtoc(intratearr[curline-1,1]),dtoc(intratearr[curline-1,2]),str(intratearr[curline - 1,3]*100,5,2)+"%"}
      intratearr := adel(intratearr,curline)
      asize(intratearr,length - 1)
      interest.interestgrid.deleteitem(curline)
   else
      msgbox("You can not delete all the lines!!!")
   endif
else
   msgbox("You have to select a line to delete")
endif
setfocus(interestgrid,interest)
return nil

function okclick
stdateval := (addint.stdate1.value)
enddateval := (addint.enddate1.value)
rate1 := (addint.intrate.value)
if stdateval > enddateval
   msgbox("Starting date should be less than the ending date!")
   return nil
endif
if enddateval < stdateval
   msgbox("Ending date should be greater than the ending date!")
   return nil
endif
if rate1 > 0.0
   aadd(intratearr,{stdateval,enddateval,rate1/100})
   interest.interestgrid.additem({dtoc(stdateval),dtoc(enddateval),str(rate1,5,2)+"%"})
   release window addint
   setfocus(interestgrid,interest)
endif
return nil

function cancelclick
release window addint
setfocus(interestgrid,interest)
return nil

function modifyint
local curline := (interest.interestgrid.value)
if curline == 1
   stdateval := intratearr[curline,1]
else
   stdateval := intratearr[curline-1,2] + 1
endif
enddateval := intratearr[curline,2]
intval := intratearr[curline,3]
define window modint at 250,120 width 300 height 200 modal nosysmenu nosize
   @  10, 10 label      stdatelab  value "From"
   @  10,100 datepicker stdate1    value stdateval
   @  40, 10 label      endatelab  value "To"
   @  40,100 datepicker enddate1   value enddateval
   @  70, 10 label      intratelab value "Rate"
   @  70,100 textbox    intrate    value (intval * 100) width 50 numeric inputmask "99.99" rightalign
   @  70,160 label      per        value "%"
   @ 110, 20 button     ok1        caption "Ok" action modokclick()
   @ 110,130 button     cancel1    caption "Cancel" action modcancelclick()
end window
if curline > 1
   modint.stdate1.enabled := .f.
endif
activate window modint
return nil

function modokclick
local stdateval := (modint.stdate1.value)
local enddateval := (modint.enddate1.value)
local rate1 := (modint.intrate.value)
local curline := (interest.interestgrid.value)
if stdateval > enddateval
   msgbox("Starting date should be less than the ending date!")
   return nil
endif
if enddateval < stdateval
   msgbox("Ending date should be greater than the ending date!")
   return nil
endif
if curline < len(intratearr)
   if stdateval > intratearr[curline + 1,2] .or. enddateval > intratearr[curline + 1,2]
      msgbox("You have to delete the next line first. Because, the starting or ending date of next line is less than this starting or ending date!")
      return nil
   else
      intratearr[curline + 1,1] := enddateval + 1
      interest.interestgrid.item(curline+1) := {dtoc(intratearr[curline+1,1]),dtoc(intratearr[curline+1,2]),str(intratearr[curline+1,3]*100,5,2)+"%"}
   endif
endif
if rate1 > 0.0
   intratearr[curline] := {stdateval,enddateval,rate1/100}
   interest.interestgrid.item(curline) := {dtoc(stdateval),dtoc(enddateval),str(rate1,5,2)+"%"}
   release window modint
   setfocus(interestgrid,interest)
endif
return nil

function modcancelclick
release window modint
setfocus(interestgrid,interest)
return nil


function addline1
date1 := (interest.date1.value)
if date1 < stdate .or. date1 > enddate
   msgbox("Entry not added since the date is out of the financial year!")
   setfocus(date1,interest)
   return nil
endif
debitval := (interest.debit1.value)
creditval := (interest.credit1.value)
if debitval > 0.0 .and. creditval > 0.0
   msgexclamation("You can enter either Debit or Credit and not both!")
   interest.debit1.value := 0.0
   interest.credit1.value := 0.0
   setfocus(debit1,interest)
   return nil
endif
interest1 := (interest.interest.value)
if (interest.addline.caption) == "Add"
   if debitval > 0.0 .or. creditval > 0.0
      aadd(acarr,{date1,debitval,creditval,0.0,"",interest1})
      interest.account.additem({dtoc(date1),iif(debitval > 0.0,str(debitval,14,2),""),iif(creditval > 0.0,str(creditval,14,2),""),"",""})
      balcalc()
      interest.interest.value := .f.
      interest.debit1.value := 0.0
      interest.credit1.value := 0.0
   endif
else
   acarr[curline,1] := date1
   acarr[curline,2] := debitval
   acarr[curline,3] := creditval
   acarr[curline,4] := 0.0
   acarr[curline,5] := ""
   acarr[curline,6] := interest1
   interest.interest.value := .f.
   interest.debit1.value := 0.0
   interest.credit1.value := 0.0
   balcalc()
   interest.addline.caption := "Add"
endif
interest.interest.setfocus()
return nil



function lineselect
interest.addline.caption := "Modify"
curline := (interest.account.value)
if curline > 0
   interest.date1.value := acarr[curline,1]
   interest.debit1.value := acarr[curline,2]
   interest.credit1.value := acarr[curline,3]
   interest.interest.value := acarr[curline,6]
   setfocus(interest,interest)
endif
return nil


function exit12
close all
release window calc
return nil

function debitentered
val := (interest.debit1.value)
if val > 0.0
   setfocus(addline,interest)
endif
return nil


function balcalc
local i := 0
if len(acarr) == 0
   return nil
endif
for i := 1 to len(acarr)
   if i == 1
      if acarr[i,2] == 0.0
         acarr[i,4] := acarr[i,3]
    acarr[i,5] := "Cr"
      else
         acarr[i,4] := acarr[i,2]
    acarr[i,5] := "Dr"
      endif
   else
      bal1 := acarr[i-1,4]
      if acarr[i,2] > 0.0
         if acarr[i-1,5] == "Dr"
       acarr[i,4] := bal1 + acarr[i,2]
       acarr[i,5] := "Dr"
    else
       if acarr[i,2] > bal1
          acarr[i,4] := acarr[i,2] - bal1
          acarr[i,5] := "Dr"
       else
          acarr[i,4] := bal1 - acarr[i,2]
          acarr[i,5] := "Cr"
       endif
    endif
      else
         if acarr[i-1,5] == "Cr"
       acarr[i,4] := bal1 + acarr[i,3]
       acarr[i,5] := "Cr"
    else
       if acarr[i,3] >= bal1
          acarr[i,4] := acarr[i,3] - bal1
          acarr[i,5] := "Cr"
       else
          acarr[i,4] := bal1 - acarr[i,3]
          acarr[i,5] := "Dr"
       endif
    endif
      endif
   endif
//   interest.account.additem({dtoc(acarr[i,1]),iif(acarr[i,2] > 0.0,str(acarr[i,2],14,2),""),iif(acarr[i,3] > 0.0,str(acarr[i,3],14,2),""),str(acarr[i,4],14,2),acarr[i,5]})
next i
//interest.account.value := (interest.account.itemcount)
return nil

function finished
local i := 0
local linedata := {}
asize(acarr1,0)
asize(acarr2,0)
asize(prodarr,0)
asize(resultarr,0)
asize(intdates,0)
asize(acarr,0)

for i := 1 to interest.account.itemcount
   linedata := interest.account.item(i)
   aadd(acarr,{linedata[1],linedata[2],linedata[3],0.0,"",iif(linedata[4] == 1,.f.,.t.)})
next i

asize(intratearr,0)
for i := 1 to interest.interestgrid.itemcount
   linedata := interest.interestgrid.item(i)
   aadd(intratearr,{linedata[1],linedata[2],linedata[3]/100})
next i



if len(acarr) == 0
   msgexclamation("You have to enter the account copy in the input section.")
   return nil
endif
balcalc()
if len(acarr) == 0
   msgexclamation("You have to enter the account copy in the input section.")
   return nil
endif
totaldays := enddate - stdate + 1
interestcr := iif(interest.intcr1.value == 1,.f.,.t.)
compound := (interest.compoundsel.value)
month1 := month(stdate)
do case
   case compound == 1
      curdate := stdate
      for i := 1 to 12
         monthend := eom(curdate)
         aadd(intdates,monthend)
         curdate := monthend + 1
      next i
   case compound == 2
      curdate := stdate
      for i := 1 to 4
         if month(curdate) <= 10
            month1 := month(curdate) + 2
            year1 := year(curdate)
         else
            month1 := month(curdate) + 2 - 12
            year1 := year(curdate) + 1
         endif
         quarterend := eom(ctod(alltrim(str(day(curdate),2,0))+"/"+alltrim(str(month1,2,0))+"/"+alltrim(str(year1,4,0))))
         aadd(intdates,quarterend)
         curdate := quarterend + 1
      next i
   case compound == 3
      curdate := stdate
      for i := 1 to 2
         if month(curdate) <= 7
            month1 := month(curdate) + 5
            year1 := year(curdate)
         else
            month1 := month(curdate) + 5 - 12
            year1 := year(curdate) + 1
         endif
         halfend := eom(ctod(alltrim(str(day(curdate),2,0))+"/"+alltrim(str(month1,2,0))+"/"+alltrim(str(year1,4,0))))
         aadd(intdates,halfend)
         curdate := halfend + 1
      next i
   case compound == 4
      aadd(intdates,enddate)
endcase
if len(intdates) == 0
   msginfo("Something is wrong. Intdates 0")
   return nil
endif
curdate := stdate
found1 := .f.
curintdate := 0
for i := 1 to len(intdates)
   if acarr[1,1] <= intdates[i] .and. .not. found1
      curintdate := i
      found1 := .t.
   endif
next i
if curintdate == 0
   msgexclamation("Something wrong")
   return nil
endif
if acarr[len(acarr),1] > enddate
   msgexclamation("This program cannot calculate interest for more than one financial year!")
   return nil
endif
acarr1 := aclone(acarr)
lent := .f.
i := 1
do while .not. lent
   if i == len(acarr1)
      lent := .t.
   endif
   if acarr1[i,6]
      acarr1 := adel(acarr1,i)
      asize(acarr1,len(acarr1) - 1)
   else
      i := i + 1
   endif
enddo
tempdate := acarr1[1,1]
i := 1
debited := .f.
interest.product.deleteallitems()
do while i < len(acarr1)
   nextdate := acarr1[i+1,1]
   if nextdate > tempdate
      if !acarr1[i,6]
         if nextdate <= intdates[curintdate]
            nodays := nextdate - tempdate
            if .not. debited
               aadd(prodarr,{tempdate,nextdate,nodays,acarr1[i,2],acarr1[i,3],.f.})
            else
               aadd(prodarr,{tempdate,nextdate,nodays,0.0,0.0,.f.})
            endif
            tempdate := nextdate
            i := i + 1
            debited := .f.
         else   
            nodays := intdates[curintdate] - tempdate + 1
            if .not. debited
               aadd(prodarr,{tempdate,intdates[curintdate],nodays,acarr1[i,2],acarr1[i,3],.f.})
               debited := .t.
            else
               aadd(prodarr,{tempdate,intdates[curintdate],nodays,0.0,0.0,.f.})
            endif
            aadd(prodarr,{intdates[curintdate],ctod("  /  /    "),0,0.0,0.0,.t.})
            tempdate := intdates[curintdate] + 1
            curintdate := curintdate + 1
         endif
      else
         i := i + 1
         debited := .f.
      endif
   else
      if nextdate == tempdate
         aadd(prodarr,{tempdate,nextdate,0,acarr1[i,2],acarr1[i,3],.f.})
      endif
      debited := .f.
      i := i + 1
   endif
enddo
if i == len(acarr1)
   tempdate := acarr1[i,1]
   nodays := intdates[curintdate] - tempdate + 1
   aadd(prodarr,{tempdate,intdates[curintdate],nodays,acarr1[i,2],acarr1[i,3],.f.})
   aadd(prodarr,{intdates[curintdate],ctod("  /  /    "),0,0.0,0.0,.t.})
endif
for i := curintdate + 1 to len(intdates)
   aadd(prodarr,{intdates[i],ctod("  /  /    "),(intdates[i] - intdates[i -1]),0.0,0.0,.t.})
next i
cumproduct := 0.0
curproduct := 0.0
balance := 0.0
totint := 0.0
curint := 0.0
interestline := 0
for i := 1 to len(intratearr)
   if acarr[1,1] >= intratearr[i,1] .and. acarr[1,1] <= intratearr[i,2]
      curintrate := intratearr[i,3]
      interestline := i
      i := len(intratearr)
   endif
next i
if interestline == 0
   msgbox("Something wrong. Check interest rates.")
   return nil
endif
totdb := 0.0
totcr := 0.0
grtotdb := 0.0
grtotcr := 0.0
grtotint := 0.0
totdays := 0
dayscount := 0
days := 0
interestcr := iif(interest.intcr1.value == 1,.f.,.t.)
for i := 1 to len(prodarr)
   totdb := totdb + prodarr[i,4]
   totcr := totcr + prodarr[i,5]
   if totdb > totcr
      dbbal := totdb - totcr
      crbal := 0.0
   else
      crbal := totcr - totdb
      dbbal := 0.0
   endif
   enddate := iif(prodarr[i,6],prodarr[i,1],prodarr[i,2])
   days := prodarr[i,3]
   curproduct := 0.0
   if .not. prodarr[i,6]
      if interestline < len(intratearr)
         if enddate > intratearr[interestline,2]
            balancedays := days
            curdays := intratearr[interestline,2] - (enddate - balancedays)
            totdays := totdays + curdays
            balancedays := balancedays - curdays
            if dbbal > 0.0
               curproduct := dbbal * curdays
            else
               if interestcr
                  curproduct := crbal * curdays * -1
               else
                  curproduct := 0.0
               endif
            endif
            cumproduct := cumproduct + curproduct
            curint := round(cumproduct * curintrate / totaldays,2)
            totint := curint + totint
            interest.product.additem({dtoc(prodarr[i,1]),;
                                      "Rate Change",;
                                      iif(prodarr[i,4] > 0.0,str(prodarr[i,4],14,2),""),;
                                      iif(prodarr[i,5] > 0.0,str(prodarr[i,5],14,2),""),;
                                      str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                      iif(dbbal > 0.0,"Dr","Cr"),;
                                      str(curdays,3,0),;
                                      str(curproduct,14,2),;
                                      str(cumproduct,14,2),;
                                      str(curintrate*100,5,2)+"%",;
                                      str(totint,14,2)})
         
            cumproduct := 0.0
            curproduct := 0.0
            interestline := interestline + 1
            curintrate := intratearr[interestline,3]
            do while (enddate > intratearr[interestline,2])
               curdays := intratearr[interestline,2] - (enddate - balancedays)
               totdays := totdays + curdays
               balancedays := balancedays - curdays
               if dbbal > 0.0
                  curproduct := dbbal * curdays
               else
                  if interestcr
                     curproduct := crbal * curdays * -1
                  else
                     curproduct := 0.0
                  endif
               endif
               cumproduct := cumproduct + curproduct
               curint := round(cumproduct * curintrate / totaldays,2)
               totint := curint + totint

               interest.product.additem({dtoc(intratearr[interestline,1]),;
                                         "Rate Change",;
                                         "",;
                                         "",;
                                         str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                         iif(dbbal > 0.0,"Dr","Cr"),;
                                         str(curdays,3,0),;
                                         str(curproduct,14,2),;
                                         str(cumproduct,14,2),;
                                         Str(curintrate*100,5,2)+"%",;
                                         str(totint,14,2)})
               cumproduct := 0.0
               curproduct := 0.0
               interestline := interestline + 1
               curintrate := intratearr[interestline,3]
            enddo
            curdays := balancedays
            totdays := totdays + curdays
            balancedays := balancedays - curdays
            if dbbal > 0.0
               curproduct := dbbal * curdays
            else
               if interestcr
                  curproduct := crbal * curdays * -1
               else
                  curproduct := 0.0
               endif
            endif
            cumproduct := cumproduct + curproduct
       
            interest.product.additem({dtoc(intratearr[interestline,1]),;
                                      "Rate Change",;
                                      "",;
                                      "",;
                                      str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                      iif(dbbal > 0.0,"Dr","Cr"),;
                                      str(curdays,3),;
                                      str(curproduct,14,2),;
                                      str(cumproduct,14,2),;
                                      Str(curintrate*100,5,2)+"%",;
                                      str(totint+(cumproduct * curintrate / totaldays),14,2)})

         else
            if days > 0 .or. prodarr[i,4] > 0.0 .or. prodarr[i,5] > 0.0
               curdays := days
               totdays := totdays + curdays
               if dbbal > 0.0
                  curproduct := dbbal * curdays
               else
                  if interestcr
                     curproduct := crbal * curdays * -1
                  else
                     curproduct := 0.0
                  endif
               endif
               cumproduct := cumproduct + curproduct

               interest.product.additem({dtoc(prodarr[i,1]),;
                                         "",;
                                         iif(prodarr[i,4] > 0.0,str(prodarr[i,4],14,2),""),;
                                         iif(prodarr[i,5] > 0.0,str(prodarr[i,5],14,2),""),;
                                         str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                         iif(dbbal > 0.0,"Dr","Cr"),;
                                         str(curdays,3),;
                                         str(curproduct,14,2),;
                                         str(cumproduct,14,2),;
                                         transform(curintrate*100,"999.99")+"%",;
                                         str(totint+(cumproduct * curintrate / totaldays),14,2)})
                              
               
            endif
         endif
      else
         if days > 0 .or. prodarr[i,4] > 0.0 .or. prodarr[i,5] > 0.0
            curdays := days
            totdays := totdays + curdays
            if dbbal > 0.0
               curproduct := dbbal * days
            else
               if interestcr
                  curproduct := crbal * days * -1
               else
                  curproduct := 0.0
               endif
            endif
            cumproduct := cumproduct + curproduct
          
            interest.product.additem({dtoc(prodarr[i,1]),;
                                      "",;
                                      iif(prodarr[i,4] > 0.0,str(prodarr[i,4],14,2),""),;
                                      iif(prodarr[i,5] > 0.0,str(prodarr[i,5],14,2),""),;
                                      str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                      iif(dbbal > 0.0,"Dr","Cr"),;
                                      str(curdays,3),;
                                      str(curproduct,14,2),;
                                      str(cumproduct,14,2),;
                                      transform(curintrate*100,"999.99")+"%",;
                                      str(totint+(cumproduct * curintrate / totaldays),14,2)})
         endif
      endif
      aadd(acarr2,{prodarr[i,1],iif(prodarr[i,4] > 0.0,prodarr[i,4],0.0),iif(prodarr[i,5] > 0.0,prodarr[i,5],0.0),iif(dbbal > 0.0,dbbal,crbal),iif(dbbal > 0.0,"Dr","Cr"),.f.})
   else
      if interestline < len(intratearr)
         if enddate > intratearr[interestline,2]
            balancedays := days
            curdays := intratearr[interestline,2] - (enddate - balancedays)
            totdays := totdays + curdays
            balancedays := balancedays - curdays
            if dbbal > 0.0
               curproduct := dbbal * curdays
            else
               if interestcr
                  curproduct := crbal * curdays * -1
               else
                  curproduct := 0.0
               endif
            endif
            cumproduct := cumproduct + curproduct
            curint := round(cumproduct * curintrate / totaldays,2)
            totint := curint + totint

            interest.product.additem({dtoc(prodarr[i,1]),;
                                      "Rate Change",;
                                      "",;
                                      "",;
                                      str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                      iif(dbbal > 0.0,"Dr","Cr"),;
                                      str(curdays,3),;
                                      str(curproduct,14,2),;
                                      str(cumproduct,14,2),;
                                      transform(curintrate*100,"999.99")+"%",;
                                      str(totint,14,2)})
              
       
            cumproduct := 0.0
            curproduct := 0.0
            interestline := interestline + 1
            curintrate := intratearr[interestline,3]
            do while (enddate > intratearr[interestline,2])
               curdays := intratearr[interestline,2] - (enddate - balancedays)
               totdays := totdays + curdays
               balancedays := balancedays - curdays
               if dbbal > 0.0
                  curproduct := dbbal * curdays
               else
                  if interestcr
                     curproduct := crbal * curdays * -1
                  else
                     curproduct := 0.0
                  endif
               endif
               cumproduct := cumproduct + curproduct
               curint := round(cumproduct * curintrate / totaldays,2)
               totint := curint + totint

               interest.product.additem({dtoc(intratearr[interestline,1]),;
                                         "Rate Change",;
                                         "",;
                                         "",;
                                         str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                         iif(dbbal > 0.0,"Dr","Cr"),;
                                         str(curdays,3,0),;
                                         str(curproduct,14,2),;
                                         str(cumproduct,14,2),;
                                         transform(curintrate*100,"999.99")+"%",;
                                         str(totint,14,2)})
             
                    
          
               cumproduct := 0.0
               curproduct := 0.0
               interestline := interestline + 1
               curintrate := intratearr[interestline,3]
            enddo
            curdays := balancedays
            totdays := totdays + curdays
            balancedays := balancedays - curdays
            if dbbal > 0.0
               curproduct := dbbal * curdays
            else
               if interestcr
                  curproduct := crbal * curdays * -1
               else
                  curproduct := 0.0
               endif
            endif
            cumproduct := cumproduct + curproduct
         else
            curdays := days
            totdays := totdays + curdays
            if dbbal > 0.0
               curproduct := dbbal * days
            else
               if interestcr
                  curproduct := crbal * days * -1
               else
                  curproduct := 0.0
               endif
            endif
            cumproduct := cumproduct + curproduct
         endif
      else
         curdays := days
         totdays := totdays + curdays
         if dbbal > 0.0
            curproduct := dbbal * days
         else
            if interestcr
               curproduct := crbal * days * -1
            else
               curproduct := 0.0
            endif
         endif
         cumproduct := cumproduct + curproduct
      endif
      if cumproduct != 0.0 .and. curproduct != 0.0 
      
         interest.product.additem({dtoc(prodarr[i,1]),;
                                   "",;
                                   "",;
                                   "",;
                                   str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                   iif(dbbal > 0.0,"Dr","Cr"),;
                                   str(curdays,3,0),;
                                   str(curproduct,14,2),;
                                   str(cumproduct,14,2),;
                                   transform(curintrate*100,"999.99")+"%",;
                                   str(totint+(cumproduct * curintrate / totaldays),14,2)})
      endif
      curint := round(cumproduct * curintrate / totaldays,2)
      totint := totint + curint
      if totint > 0.0
         totdb := totdb + totint
      else
         totcr := totcr - totint
      endif
      if totdb > totcr
         dbbal := totdb - totcr
         crbal := 0.0
      else
         crbal := totcr - totdb
         dbbal := 0.0
      endif
      if totint != 0.0
         interest.product.additem({dtoc(prodarr[i,1]),;
                                   "Interest",;
                                   iif(totint > 0.0,str(totint,14,2),""),;
                                   iif(totint < 0.0,str(abs(totint),14,2),""),;
                                   str(iif(dbbal > 0.0,dbbal,crbal),14,2),;
                                   iif(dbbal > 0.0,"Dr","Cr"),;
                                   "",;
                                   "",;
                                   "",;
                                   transform(curintrate*100,"999.99")+"%",;
                                   ""})
         aadd(acarr2,{prodarr[i,1],iif(totint > 0.0,totint,0.0),iif(totint <= 0.0,abs(totint),0.0),iif(dbbal > 0.0,dbbal,crbal),iif(dbbal > 0.0,"Dr","Cr"),.t.})
         totint := 0.0
         curdays := 0
         cumproduct := 0.0
         curproduct := 0.0
      endif
   endif
next i
totdbint1 := 0.0
totcrint1 := 0.0
for i := 1 to len(acarr)
   if acarr[i,6]
      if acarr[i,2] > 0.0
         totdbint1 := totdbint1 + acarr[i,2]
      else
         if acarr[i,3] > 0.0
            totcrint1 := totcrint1 + acarr[i,3]
         endif
      endif
   endif
next i
if totdbint1 > totcrint1
   interest.oldrep.value := "Total Interest Debited       :"+str(totdbint1 - totcrint1,14,2) 
else
   if totcrint1 > totdbint1
   interest.oldrep.value := "Total Interest credited       :"+str(totcrint1 - totdbint1,14,2)
   endif
endif
totdbint2 := 0.0
totcrint2 := 0.0
for i := 1 to len(acarr2)
   if acarr2[i,6]
      if acarr2[i,2] > 0.0
         totdbint2 := totdbint2 + acarr2[i,2]
      else
         if acarr2[i,3] > 0.0
            totcrint2 := totcrint2 + acarr2[i,3]
         endif
      endif
   endif
next i
if totdbint2 > totcrint2
   interest.newrep.value := "Total Interest to be Debited :"+str(totdbint2 - totcrint2,14,2) 
else
   if totcrint2 > totdbint2
   interest.newrep.value := "Total Interest to be credited :"+str(totcrint2 - totdbint2,14,2) 
   endif
endif
resultarr := {}
for i := 1 to len(acarr2)
   aadd(resultarr,{dtoc(acarr2[i,1]),iif(acarr2[i,6],"Interest",""),iif(acarr2[i,2] > 0,str(acarr2[i,2],14,2),''),iif(acarr2[i,3] > 0.0,str(acarr2[i,3],14,2),''),str(acarr2[i,4],14,2),acarr2[i,5]})
next i
return nil




function eom(date1)
local montharr := {31,28,31,30,31,30,31,31,30,31,30,31}
set date ital
set cent on
if month(date1) == 2
   if mod(year(date1),4) == 0
      if mod(year(date1),100) == 0
         if mod(year(date1),400) == 0
       day1 := 29
    else
       day1 := 28
    endif
      else
         day1 := 29
      endif
   else
      day1 := 28
   endif
else
   day1 := montharr[month(date1)]
endif
return (ctod(alltrim(str(day1,2,0))+"/"+alltrim(str(month(date1),2,0))+"/"+alltrim(str(year(date1),4,0)) ))



function clearallitems
asize(acarr,0)
filename := ""
interest.name.value := ""
interest.account.deleteallitems()
interest.title := "Interest Calculation - Product Method - (New account)."
return nil


function saveaccount1
if len(alltrim(filename)) == 0
   filename := putfile({{"Comma Separated Value Files (*.csv)","*.csv"}},"Enter a filename",".")
   if len(alltrim(filename)) == 0
      return nil
   endif
   if at(".CSV",upper(alltrim(filename))) == 0
      filename := alltrim(filename) + ".csv"
   endif
   if file(filename)
      confirmed := .f.
      do while .not. confirmed
         if !msgyesno("Are you sure to Overwrite the existing file?","File already exists!")
            if msgyesno("Do you want to cancel saving?","Save file")
               filename := ""
               return nil
               confirmed := .t.
            else
               filename := putfile({{"Comma Separated Value Files (*.csv)","*.csv"}},"Enter a New Filename",".")
               if file(filename)
                  confirmed := .f.
               else
                  confirmed := .t.
               endif
            endif
         endif
      enddo
   endif
endif
nHandle := fopen(filename,2)
if nHandle < 0
   msgstop("File Open Error!")
   return nil
endif

for i := 1 to interest.account.itemcount
   linedata := interest.account.item(i)
   cBuffer := dtoc(linedata[1])+","+iif(linedata[2] > 0.0,alltrim(str(linedata[2],14,2)),"")+","+iif(linedata[3] > 0.0,alltrim(str(linedata[3],14,2)),"")+","+iif(linedata[4]==2,"1","0")+chr(13)+chr(10)
   if fwrite(nhandle,cBuffer) == 0
      msgstop("File Write error!")
   endif
next i
fclose(nHandle)
msginfo("File saved successfully.")
return nil



function loadaccount1
filename := getfile({{"Accounts","*.acc"}},"Select a file",".")
if len(alltrim(filename)) == 0 .or. !file(alltrim(filename))
   return nil
endif
interestcr1 := .f.
month1 := 0
comp1 := 0
intlines := 0
name1 := ""
line1 := ''
length1 := 0
year1 := 0
begin ini file filename
   get interestcr1 section "Settings" entry "interestcr"
   get year1 section "Settings" entry "year"
   get month1 section "Settings" entry "startmonth"
   get comp1 section "Settings" entry "compounding"
   get intlines section "Settings" entry "intlines"
   asize(intratearr,0)
   for i := 1 to intlines
      aadd(intratearr,{ctod("  /  /    "),ctod("  /  /    "),0.0})
      get line1 section "Settings" entry "intline"+alltrim(str(i))
      intratearr[i,1] := ctod(substr(line1,1,10))
      intratearr[i,2] := ctod(substr(line1,11,10))
      intratearr[i,3] := val(alltrim(substr(line1,21,6)))
   next i
   get name1 section "Accounts" entry "name"
   get length1 section "Accounts" entry "length"
   asize(acarr,0)
   interest.account.deleteallitems()
   for i := 1 to length1
      aadd(acarr,{ctod("  /  /    "),0.0,0.0,0.0,"",.f.})
      interest.account.additem({"","","","",""})
      get line1 section "Accounts" entry "ac"+alltrim(str(i))
      acarr[i,1] := ctod(substr(line1,1,10))
      acarr[i,2] := val(alltrim(substr(line1,11,14)))
      acarr[i,3] := val(alltrim(substr(line1,25,14)))
      acarr[i,6] := iif(substr(line1,39,1) == "T",.t.,.f.)
   next i
end ini
balcalc()
if year1 > 0
   interest.yearselect.value := year1
endif
interest.intcr1.value := interestcr1
interest.monthselect.value := month1
interest.compoundsel.value := comp1
interest.name.value := name1
interest.interestgrid.deleteallitems()
for i := 1 to len(intratearr)
   stdateval := intratearr[i,1]
   enddateval := intratearr[i,2]
   rate1 := intratearr[i,3]
   interest.interestgrid.additem({dtoc(stdateval),dtoc(enddateval),str(rate1*100,5,2)+"%"})
next i
interest.title := "Interest Calculation - Product Method - ("+filename+")."
return nil

function verifysave
if len(acarr) == 0
   return nil
else
   if len(alltrim(filename)) == 0
      if msgyesno("Are you sure to exit without saving the data?","File Not Saved!")
         return nil
      else
         saveaccount1()
         return nil
      endif
   else
      interestcr1 := .f.
      month1 := 0
      comp1 := 0
      intlines := 0
      name1 := ""
      line1 := ''
      length1 := 0
      checkarr := {}
      name2 := (interest.name.value)
      checkarr := aclone(acarr)
      begin ini file filename
         get name1 section "Accounts" entry "name"
         get length1 section "Accounts" entry "length"
         asize(checkarr,0)
         for i := 1 to length1
            aadd(checkarr,{ctod("  /  /    "),0.0,0.0,0.0,"",.f.})
           get line1 section "Accounts" entry "ac"+alltrim(str(i))
           checkarr[i,1] := ctod(substr(line1,1,10))
           checkarr[i,2] := val(alltrim(substr(line1,11,14)))
           checkarr[i,3] := val(alltrim(substr(line1,25,14)))
           checkarr[i,6] := iif(substr(line1,39,1) == "T",.t.,.f.)
         next i
      end ini
      if .not. upper(alltrim(name1)) == upper(alltrim(name2))
         if msgyesno("Are you sure to exit without saving the data?","File Not Saved!")
            return nil
         else
            saveaccount1()
            return nil
         endif
      endif
      if .not. len(acarr) == len(checkarr)
         if msgyesno("Are you sure to exit without saving the data?","File Not Saved!")
            return nil
         else
            saveaccount1()
            return nil
         endif
      endif
      for i := 1 to len(acarr)
         if .not. (checkarr[i,1] == acarr[i,1] .and. checkarr[i,2] == acarr[i,2] .and. checkarr[i,3] == acarr[i,3] .and. checkarr[i,6] == acarr[i,6])
            if msgyesno("Are you sure to exit without saving the data?","File Not Saved!")
               return nil
            else
               saveaccount1()
               return nil
            endif
    endif
      next i
   endif
endif
return nil

function saveasaccount
filename := ""
if len(alltrim(filename)) == 0
   filename := putfile({{"Accounts","*.acc"}},"Enter a filename",".")
   if len(alltrim(filename)) == 0
      return nil
   endif
   if at(".ACC",upper(alltrim(filename))) == 0
      filename := alltrim(filename) + ".acc"
   endif
   if file(filename)
      do while !msgyesno("Are you sure to Overwrite the existing file?","File already exists!")
         if msgyesno("Do you want to cancel saving?","Save file")
       filename := ""
       return nil
    else
            filename := putfile({{"Accounts","*.acc"}},"Enter a filename",".")
       endif
      enddo
   endif
endif
begin ini file filename
   set section "Settings" entry "interestcr" to (interest.intcr1.value)
   set section "Settings" entry "year" to (interest.yearselect.value)
   set section "Settings" entry "startmonth" to (interest.monthselect.value)
   set section "Settings" entry "compounding" to (interest.compoundsel.value)
   set section "Settings" entry "intlines" to len(intratearr)
   for i := 1 to len(intratearr)
      set section "Settings" entry "intline"+alltrim(str(i)) to dtoc(intratearr[i,1])+dtoc(intratearr[i,2])+str(intratearr[i,3],6,4)
   next i
   set section "Accounts" entry "name" to (interest.name.value)
   set section "Accounts" entry "length" to len(acarr)
   for i := 1 to len(acarr)
      set section "Accounts" entry "ac"+alltrim(str(i)) to dtoc(acarr[i,1])+str(acarr[i,2],14,2)+str(acarr[i,3],14,2)+iif(acarr[i,6],"T","F")
   next i
end ini
return nil

function newprintpage
return nil


function printhead
return nil




function interestratekeyinit
on key CONTROL+A of interest action addinterestraterow()
on key DELETE of interest action delinterestraterow()
return nil

function interestratekeyrelease
release key CONTROL+A of interest
release key DELETE of interest
return nil

function addinterestraterow
local alinedata := {}
if interest.interestgrid.itemcount > 0
   alinedata := interest.interestgrid.item(interest.interestgrid.itemcount)
   if alinedata[2] >= enddate
      msgstop("Interest Rates are well defined for the year to calculate the interest. To add a row, first alter the last row!")
      return nil
   else
      interest.interestgrid.additem({alinedata[2]+1,enddate,initrate*100})
      interest.interestgrid.value := {interest.interestgrid.itemcount,2}
   endif
endif
return nil

function delinterestraterow
local aValue := interest.interestgrid.value
local alinedata1 := {}
local alinedata2 := {}
if aValue[1] == 1 .and. interest.interestgrid.itemcount == 1
   msgstop("You cannot delete all the rows!")
   return nil
else
   do case
      case aValue[1] == 1
         alinedata1 := interest.interestgrid.item(2)
         alinedata1[1] := stdate
         interest.interestgrid.item(2) := alinedata1
         interest.interestgrid.deleteitem(1)
         interest.interestgrid.value := {1,2}
      case aValue[1] == interest.interestgrid.itemcount
         alinedata1 := interest.interestgrid.item(aValue[1] - 1)
         alinedata1[2] := enddate
         interest.interestgrid.item(aValue[1] - 1) := alinedata1
         interest.interestgrid.deleteitem(aValue[1])
         interest.interestgrid.value := {aValue[1]-1,2}
      otherwise
         alinedata1 := interest.interestgrid.item(aValue[1] + 1)
         alinedata2 := interest.interestgrid.item(aValue[1] - 1)
         alinedata1[1] := alinedata2[2]+1
         interest.interestgrid.item(aValue[1]+1) := alinedata1
         interest.interestgrid.deleteitem(aValue[1])
         interest.interestgrid.value := {aValue[1],2}
   endcase            
endif      
return nil

function interestrateverify
if this.cellvalue < 0.0
   return .f.
endif
return .t.



function interesttodateverify
local dDate := this.cellvalue
local alinedata1 := {}
local nValue := interest.interestgrid.value
local i := 0
alinedata1 := interest.interestgrid.item(nValue)
if dDate <= alinedata1[1] 
   return .f.
else
   if dDate > enddate
      return .f.
   else
      if dDate == enddate
         if nValue < interest.interestgrid.itemcount
            if msgyesno("End date of the year is entered. All the lines below would be deleted! Do you agree?")
               for i := interest.interestgrid.itemcount to nValue + 1 step -1
                  interest.interestgrid.deleteitem(i)
               next i
               return .t.
            else
               return .f.
            endif
         else
            return .t.
         endif
      else
         if nValue == interest.interestgrid.itemcount
            return .t.
         else
            alinedata1 := interest.interestgrid.item(nValue+1)
            if dDate >= alinedata1[2]
               return .f.
            else
               alinedata1[1] := dDate + 1
               interest.interestgrid.item(nValue+1) := alinedata1
               return .t.
            endif
         endif
      endif
   endif
endif
return .f.

function accountkeyinit
on key INSERT of interest action insertaccountrow()
on key CONTROL+A of interest action addaccountrow()
on key CONTROL+I of interest action insertaccountrow()
on key DELETE of interest action delaccountrow()
return nil

function accountkeyrelease
release key INSERT of interest
release key DELETE of interest
release key CONTROL+I of interest
release key CONTROL+A of interest
return nil

function addaccountrow
local nValue := interest.account.itemcount
local stdate1 := stdate
local linedata := {}
if interest.account.itemcount > 0 .and. nValue > 0
   linedata := interest.account.item(nValue)
   stdate1 := linedata[1]
endif
interest.account.additem({stdate1,0.0,0.0,1})
interest.account.value := interest.account.itemcount
return nil

function insertaccountrow
local nvalue := interest.account.value
local linedata := {}
local adata := {}
local i := 0
if nvalue == 0 
   addaccountrow()
   return nil
endif 
for i := 1 to interest.account.itemcount
   aadd(adata,interest.account.item(i))
next i
interest.account.deleteallitems()
if nvalue == 1
   interest.account.additem({stdate,0.0,0.0,1})
else
   for i := 1 to nvalue - 1
      interest.account.additem(adata[i])
   next i
   interest.account.additem({adata[nvalue-1,1],0.0,0.0,1})
endif
for i := nvalue to len(adata)
   interest.account.additem(adata[i])
next i
interest.account.value := nvalue   
return nil

function delaccountrow
local nValue := interest.account.value
if nValue == 0
   return nil
endif
interest.account.deleteitem(nValue)
if nValue < interest.account.itemcount
   interest.account.value := nValue
else
   interest.account.value := interest.account.itemcount
endif   
return nil

function accountdebitverify
local nValue := interest.account.value
local linedata := {}
linedata := interest.account.item(nValue)
if linedata[3] == 0.0 
   if this.cellvalue >= 0.0 
      return .t.
   endif 
else
   if this.cellvalue == 0.0 
      return .t.
   endif 
endif
return .f.

function accountcreditverify
local nValue := interest.account.value
local linedata := {}
linedata := interest.account.item(nValue)
if linedata[2] == 0.0 
   if this.cellvalue >= 0.0 
      return .t.
   endif 
else
   if this.cellvalue == 0.0 
      return .t.
   endif 
endif
return .f.

function datechanged
stdate := interest.stdate.value
enddate := ctod(substr(dtoc(stdate),1,6)+str(year(stdate)+1)) - 1
interest.enddate.value := enddate
interest.interestgrid.deleteallitems()
interest.account.deleteallitems()
if stdate <= enddate
   interest.interestgrid.additem({stdate,enddate,initrate*100})
   interest.interestgrid.value := 1
else
   msgstop("Starting date is greater than end date! Please change the starting/ending date accordingly")
   return nil   
endif
return nil

function txndateverify
local nvalue := interest.account.value
local prevdate := stdate
local nextdate := enddate
local linedata := {}
if nvalue == 1 
   if interest.account.itemcount > 1
      linedata := interest.account.item(2)
      nextdate := linedata[1]
   endif   
else
   if interest.account.itemcount == nvalue
      linedata := interest.account.item(nvalue - 1)
      prevdate := linedata[1]
   else
      linedata := interest.account.item(nvalue - 1)
      prevdate := linedata[1]
      linedata := interest.account.item(nvalue + 1)               
      nextdate := linedata[1]
   endif
endif
if this.cellvalue >= prevdate .and. this.cellvalue <= nextdate
   return .t.
endif
return .f.

function importfromfile(filename1)
&& local aarr := {}
&& local aarr1 := {}
&& LOCAL aEOL := {chr(13)+chr(10),chr(10)+chr(13),chr(10),chr(13)}
&& local cLine 
&& local i := 0
&& local nHandle := FOpen(filename1)
&& if nHandle < 1
   && msgstop("File open error!")
   && return nil
&& endif
&& lc := 0
&& DO WHILE HB_FReadLine( nHandle, @cLine ,aEOL) == 0
   && linearr := hb_aTokens(substr(cLine,1),",") 
   && if len(linearr) == 3 .or. len(linearr) == 4
      && aadd(aarr,linearr)
   && endif
&& enddo

&& for i := 1 to len(aarr)
   && aadd(aarr1,{ctod(aarr[i,1]),val(alltrim(aarr[i,2])),val(alltrim(aarr[i,3])),iif(len(aarr[i]) > 3,iif(val(alltrim(aarr[i,4]))==1,2,1),1)})
&& next i
&& asort(aarr1,,,{|x,y| x[1] < y[1]})
&& if len(aarr1) > 0
   && if aarr1[1,1] < stdate
      && msgstop("Starting date should be before "+dtoc(aarr1[1,1])+"! Alter that and import data again.")
      && return nil
   && endif
   && if aarr1[len(aarr1),1] > enddate
      && msgstop("Starting date should be after "+dtoc(aarr1[len(aarr1),1])+"! Alter that and import data again.")
      && return nil
   && endif
&& endif
&& fclose(nHandle)
&& filename := filename1
&& interest.account.deleteallitems()
&& for i := 1 to len(aarr1)
   && interest.account.additem(aarr1[i])
&& next i
return nil

function currentacrepprint
&& local aHeaders := {interest.oldrep.value,interest.newrep.value}

&& print grid product of interest headers aHeaders columnsum {{.f.,""},{.f.,""},{.t.,"99999999999.99"},{.t.,"99999999999.99"},{.f.,""},{.f.,""},{.t.,"999"},{.f.,""},{.f.,""},{.f.,""},{.f.,""}}

return nil

&& #pragma BEGINDUMP

&& #include "hbapi.h"
&& #include "hbapifs.h"
&& #include "hbset.h"
&& #include "hbapiitm.h"
&& #include "hbapierr.h"

&& #define READING_BLOCK      4096

&& static char * hb_fsReadLine( HB_FHANDLE hFileHandle, HB_ISIZ * plBuffLen, const char ** pTerm, HB_ISIZ * pnTermSizes, HB_ISIZ nTerms, HB_BOOL * pbFound, HB_BOOL * pbEOF )
&& {
   && HB_ISIZ nPosTerm = 0, nPos, nPosition;
   && int nTries;
   && HB_ISIZ nRead = 0, nOffset, nSize;
   && char * pBuff;

   && HB_TRACE(HB_TR_DEBUG, ("hb_fsReadLine(%p, %" HB_PFS "d, %p, %p, %" HB_PFS "d, %p, %p)", ( void * ) ( HB_PTRDIFF ) hFileHandle, *plBuffLen, pTerm, pnTermSizes, nTerms, pbFound, pbEOF ));

   && *pbFound = HB_FALSE;
   && *pbEOF   = HB_FALSE;
   && nTries   = 0;
   && nOffset  = 0;
   && nSize    = *plBuffLen;

   && if( *plBuffLen < 10 )
      && *plBuffLen = READING_BLOCK;

   && pBuff = ( char * ) hb_xgrab( *plBuffLen + 1 );

   && do
   && {
      && if( nTries > 0 )
      && {
         && /* pBuff can be enlarged to hold the line as needed.. */
         && nSize = ( *plBuffLen * ( nTries + 1 ) ) + 1;
         && pBuff = ( char * ) hb_xrealloc( pBuff, nSize );
         && nOffset += nRead;
      && }

      && /* read from file */
      && nRead = hb_fsReadLarge( hFileHandle, pBuff + nOffset, nSize - nOffset );

      && /* scan the read buffer */

      && if( nRead > 0 )
      && {
         && for( nPos = 0; nPos < nRead; nPos++ )
         && {
            && for( nPosTerm = 0; nPosTerm < nTerms; nPosTerm++ )
            && {
               && /* Compare with the LAST terminator byte */
               && if( pBuff[ nOffset + nPos ] == pTerm[ nPosTerm ][ pnTermSizes[ nPosTerm ] - 1 ] && ( pnTermSizes[ nPosTerm ] - 1 ) <= ( nPos + nOffset ) )
               && {
                  && *pbFound = HB_TRUE;

                  && for( nPosition = 0; nPosition < ( pnTermSizes[ nPosTerm ] - 1 ); nPosition++ )
                  && {
                     && if( pTerm[ nPosTerm ][ nPosition ] != pBuff[ nOffset + ( nPos - pnTermSizes[ nPosTerm ] ) + nPosition + 1 ] )
                     && {
                        && *pbFound = HB_FALSE;
                        && break;
                     && }
                  && }

                  && if( *pbFound )
                     && break;
               && }
            && }

            && if( *pbFound )
               && break;
         && }

         && if( *pbFound )
         && {
            && *plBuffLen = nOffset + nPos - pnTermSizes[ nPosTerm ] + 1;

            && pBuff[ *plBuffLen ] = '\0';

            && /* Set handle pointer in the end of the line */
            && hb_fsSeekLarge( hFileHandle, ( ( nRead - nPos ) * -1 ) + 1, FS_RELATIVE );

            && return pBuff;
         && }
      && }
      && else
      && {
         && if( ! *pbFound )
         && {
            && if( nTries == 0 )
            && {
               && pBuff[ 0 ] = '\0';
               && *plBuffLen = 0;
            && }
            && else
            && {
               && pBuff[ nOffset + nRead ] = '\0';
               && *plBuffLen = nOffset + nRead;
            && }

            && *pbEOF = HB_TRUE;
         && }
      && }

      && nTries++;
   && }
   && while( ( ! *pbFound ) && nRead > 0 );

   && return pBuff;
&& }


&& HB_FUNC( HB_FREADLINE )
&& {
   && PHB_ITEM pTerm1;
   && HB_FHANDLE hFileHandle  = ( HB_FHANDLE ) hb_parnint( 1 );
   && const char ** Term;
   && char * pBuffer;
   && HB_ISIZ * pnTermSizes;
   && HB_ISIZ nSize = hb_parns( 4 );
   && HB_ISIZ i, nTerms;
   && HB_BOOL bFound, bEOF;

   && if( ( !HB_ISBYREF( 2 ) ) || ( !HB_ISNUM( 1 ) ) )
   && {
      && hb_errRT_BASE_SubstR( EG_ARG, 3012, NULL, HB_ERR_FUNCNAME, 4,
         && hb_paramError( 1 ),
         && hb_paramError( 2 ),
         && hb_paramError( 3 ),
         && hb_paramError( 4 ) );
      && return;
   && }

   && if( HB_ISARRAY( 3 ) || HB_ISCHAR( 3 ) )
   && {
      && if( HB_ISARRAY( 3 ) )
      && {
         && pTerm1 = hb_param( 3, HB_IT_ARRAY );
         && nTerms = hb_arrayLen( pTerm1 );

         && if( nTerms <= 0 )
         && {
            && hb_errRT_BASE_SubstR( EG_ARG, 3012, NULL, HB_ERR_FUNCNAME, 4,
               && hb_paramError( 1 ),
               && hb_paramError( 2 ),
               && hb_paramError( 3 ),
               && hb_paramError( 4 ) );
            && return;
         && }

         && Term = ( const char ** ) hb_xgrab( sizeof( char * ) * nTerms );
         && pnTermSizes = ( HB_ISIZ * ) hb_xgrab( sizeof( HB_ISIZ ) * nTerms );

         && for( i = 0; i < nTerms; i++ )
         && {
            && Term[ i ]        = hb_arrayGetCPtr( pTerm1, i + 1 );
            && pnTermSizes[ i ] = hb_arrayGetCLen( pTerm1, i + 1 );
         && }
      && }
      && else
      && {
         && pTerm1           = hb_param( 3, HB_IT_STRING );
         && Term             = ( const char ** ) hb_xgrab( sizeof( char * ) );
         && pnTermSizes      = ( HB_ISIZ * ) hb_xgrab( sizeof( HB_ISIZ ) );
         && Term[ 0 ]        = hb_itemGetCPtr( pTerm1 );
         && pnTermSizes[ 0 ] = hb_itemGetCLen( pTerm1 );
         && nTerms           = 1;
      && }
   && }
   && else
   && {
      && Term             = ( const char ** ) hb_xgrab( sizeof( char * ) );
      && pnTermSizes      = ( HB_ISIZ * ) hb_xgrab( sizeof( HB_ISIZ ) );
      && Term[ 0 ]        = "\r\n";    /* Should be preplaced with the default EOL sequence */
      && nTerms           = 1;
      && pnTermSizes[ 0 ] = 2;
   && }

   && if( nSize == 0 )
      && nSize = READING_BLOCK;

   && pBuffer = hb_fsReadLine( hFileHandle, &nSize, Term, pnTermSizes, nTerms, &bFound, &bEOF );

   && if( ! hb_storclen_buffer( pBuffer, nSize, 2 ) )
      && hb_xfree( pBuffer );
   && hb_retns( bEOF ? -1 : 0 );
   && hb_xfree( ( void * ) Term );
   && hb_xfree( pnTermSizes );
&& }



&& #pragma ENDDUMP