#include "hmg.ch"
&& #include "hfcl.ch"

declare window interest

function rdepositinstal
local intarr2 := {360,12,4,2,1}
local instal := 0.0
local maturity := interest.rdepositmaturity.value
local intrate := interest.rdepositinterest.value / 100
local period := interest.rdepositperiod.value
local yearlycompoundings := intarr2[interest.rdepositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.rdepositinterval.value] // No. of instalements per annum
local m := 0.0
if maturity == 0.0 .or. intrate == 0.0 .or. period == 0.0
   msginfo("You have to enter Interest Rate, Term of the Deposit and Maturity Value to find out the Instalment Amount.","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   total1 := 0.0
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   if fulcomp > 0
      n := yearlyinstalments / yearlycompoundings
      l := n  + (((n * (n + 1)) / 2) * (intrate / yearlyinstalments))
      total1 := l
      for i := 2 to fulcomp
         total1 := (total1 * (1 + (intrate / yearlycompoundings))) + l
      next i
   endif
   total1 := (total1 * (1 + ((intrate / yearlyinstalments) * balacomp)))+ balacomp + (((balacomp * (balacomp + 1)) / 2) * (intrate / yearlyinstalments))
   instal := maturity / total1
   interest.rdinstalment.value := instal
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings
   total1 := (1+m)^ (yearlycompoundings / yearlyinstalments)
   for i := 2 to period
      total1 := total1 + 1
      total1 := (total1 * (1+m)^ (yearlycompoundings / yearlyinstalments))
   next i
   instal := maturity / total1
   interest.rdinstalment.value := instal
endif
interest.rdinstalment.fontcolor := {0,0,255}
interest.rdepositinterest.fontcolor := {0,0,0}
interest.rdepositperiod.fontcolor := {0,0,0}
interest.rdepositmaturity.fontcolor := {0,0,0}
interest.rdresult.value := "Instalment :"+alltrim(str(interest.rdinstalment.value,14,2))
showrecurdepositaccount()
return nil

function rdepositintrate
local intarr2 := {360,12,4,2,1}
local instal := interest.rdinstalment.value
local maturity := interest.rdepositmaturity.value
local intrate := 0.0
local period := interest.rdepositperiod.value
local yearlycompoundings := intarr2[interest.rdepositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.rdepositinterval.value] // No. of instalements per annum
local m := 0.0
if maturity == 0.0 .or. instal == 0.0 .or. period == 0.0
   msginfo("You have to enter Instalment Amount, Term of the Deposit and the Maturity Value to find out the Rate of Interest.","Interest(ing) Calculator")
   return nil
endif
if instal * period >= maturity
   msginfo("Maturity value MUST be greater than amount invested.","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   intrate := 0.00001
   crossed := .f.
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   n := yearlyinstalments / yearlycompoundings
   do while .not. crossed
      m := intrate / yearlyinstalments// rate per yearlyinstalments
      total1 := 0.0
      if fulcomp > 0
         l := n  + (((n * (n + 1)) / 2) * (intrate / yearlyinstalments))
         total1 := l
         for i := 2 to fulcomp
            total1 := (total1 * (1 + (intrate / yearlycompoundings))) + l
         next i
      endif
      total1 := (total1 * (1 + ((intrate / yearlyinstalments) * balacomp)))+ balacomp + (((balacomp * (balacomp + 1)) / 2) * (intrate / yearlyinstalments))
      if total1 * instal >= maturity
         crossed := .t.
      else
         if maturity - (total1 * instal) > 1000
            intrate := intrate + 0.0001
         else
            intrate := intrate + 0.00001
         endif
      endif
   enddo
   interest.rdepositinterest.value := intrate * 100
endif
if yearlyinstalments < yearlycompoundings
   intrate := 0.00001
   crossed := .f.
   x := (yearlycompoundings / yearlyinstalments)
   do while .not. crossed
      m := intrate / yearlycompoundings
      total1 := (1+m)^ x
      for i := 2 to period
         total1 := total1 + 1
         total1 := (total1 * (1+m)^ x)
      next i
      if total1 * instal >= maturity
         crossed := .t.
      else
         if maturity - (total1 * instal) > 1000
            intrate := intrate + 0.0001
         else
            intrate := intrate + 0.00001
         endif
      endif
   enddo
   interest.rdepositinterest.value := intrate * 100
endif
interest.rdinstalment.fontcolor := {0,0,0}
interest.rdepositinterest.fontcolor := {0,0,255}
interest.rdepositperiod.fontcolor := {0,0,0}
interest.rdepositmaturity.fontcolor := {0,0,0}
interest.rdresult.value := "Interest Rate :"+alltrim(str(interest.rdepositinterest.value,6,2))+"% p.a."
showrecurdepositaccount()
return nil

function rdepositperiod
local intarr2 := {360,12,4,2,1}
local instal := interest.rdinstalment.value
local intrate := interest.rdepositinterest.value / 100
local maturity := interest.rdepositmaturity.value
local period := 0
local yearlycompoundings := intarr2[interest.rdepositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.rdepositinterval.value] // No. of instalements per annum
local m := 0.0
if instal == 0.0 .or. intrate == 0.0 .or. maturity == 0.0
   msginfo("You have to enter Instalment Amount, Interest Rate and the Maturity Value to find out the Term of Deposit.","Interest(ing) Calculator")
   return nil
endif
if instal >= maturity
   msginfo("Maturity value MUST be greater than instalment amount!","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   period := 1
   crossed := .f.
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   n := yearlyinstalments / yearlycompoundings
   do while .not. crossed
      fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
      balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
      total1 := 0.0
      if fulcomp > 0
         l := n  + (((n * (n + 1)) / 2) * (intrate / yearlyinstalments))
         total1 := l
         for i := 2 to fulcomp
            total1 := (total1 * (1 + (intrate / yearlycompoundings))) + l
         next i
      endif
      total1 := (total1 * (1 + ((intrate / yearlyinstalments) * balacomp)))+ balacomp + (((balacomp * (balacomp + 1)) / 2) * (intrate / yearlyinstalments))
      if total1 * instal >= maturity
         crossed := .t.
      else
         period := period + 1
      endif
   enddo
   interest.rdepositperiod.value := period
endif
if yearlyinstalments < yearlycompoundings
   period := 1
   crossed := .f.
   x := (yearlycompoundings / yearlyinstalments)
   do while .not. crossed
      m := intrate / yearlycompoundings
      total1 := (1+m)^ x
      for i := 2 to period
         total1 := total1 + 1
         total1 := (total1 * (1+m)^ x)
      next i
      if total1 * instal >= maturity
         crossed := .t.
      else
         period := period + 1
      endif
   enddo
   interest.rdepositperiod.value := period
endif
interest.rdinstalment.fontcolor := {0,0,0}
interest.rdepositinterest.fontcolor := {0,0,0}
interest.rdepositperiod.fontcolor := {0,0,255}
interest.rdepositmaturity.fontcolor := {0,0,0}
interest.rdresult.value := "Term :"+alltrim(str(interest.rdepositperiod.value,6,0))
showrecurdepositaccount()
return nil

function rdepmaturity
local intarr2 := {360,12,4,2,1}
local instal := interest.rdinstalment.value
local intrate := interest.rdepositinterest.value / 100
local period := interest.rdepositperiod.value
local yearlycompoundings := intarr2[interest.rdepositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.rdepositinterval.value] // No. of instalements per annum
local m := 0.0
if instal == 0.0 .or. intrate == 0.0 .or. period == 0.0
   msginfo("You have to enter Instalment Amount, Interest Rate and the Term of the Deposit to find out the Maturity Value.","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   total1 := 0.0
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   if fulcomp > 0
      n := yearlyinstalments / yearlycompoundings
      l := n  + (((n * (n + 1)) / 2) * (intrate / yearlyinstalments))
      total1 := l
      for i := 2 to fulcomp
         total1 := (total1 * (1 + (intrate / yearlycompoundings))) + l
      next i
   endif
   total1 := (total1 * (1 + ((intrate / yearlyinstalments) * balacomp)))+ balacomp + (((balacomp * (balacomp + 1)) / 2) * (intrate / yearlyinstalments))
   maturity := total1 * instal
   interest.rdepositmaturity.value := maturity
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings
   total1 := (1+m)^ (yearlycompoundings / yearlyinstalments)
   for i := 2 to period
      total1 := total1 + 1
      total1 := (total1 * (1+m)^ (yearlycompoundings / yearlyinstalments))
   next i
   maturity := total1 * instal
   interest.rdepositmaturity.value := maturity
endif
interest.rdinstalment.fontcolor := {0,0,0}
interest.rdepositinterest.fontcolor := {0,0,0}
interest.rdepositperiod.fontcolor := {0,0,0}
interest.rdepositmaturity.fontcolor := {0,0,255}
interest.rdresult.value := "Maturity Value :"+alltrim(str(interest.rdepositmaturity.value,14,2))
showrecurdepositaccount()
return nil


function showrecurdepositaccount
local intarr2 := {360,12,4,2,1}
local instal := interest.rdinstalment.value
local intrate := interest.rdepositinterest.value / 100
local period := interest.rdepositperiod.value
local maturity := interest.rdepositmaturity.value
local yearlycompoundings := intarr2[interest.rdepositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.rdepositinterval.value] // No. of instalements per annum
LOCAL total1 := 0.0
LOCAL total2 := 0.0
local reportarr := {}
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   head1 := interest.rdepositinterval.item(interest.rdepositinterval.value)
   counter := 1
   count1 := 1
   balance := 0.0
   totint := 0
   totinst := 0
   product := 0
   interest := 0
   do while counter <= period
      product := product + balance + instal
      totinst := totinst + instal
      if mod(counter,yearlyinstalments/yearlycompoundings) == 0
         interest := round(product * m,2)
         totint := interest + totint
         product := 0.0
      endif
      if counter > (fulcomp / yearlycompoundings * yearlyinstalments)
         product := 0
         do while count1 <= balacomp
            product := product + balance + instal
            if counter == period
               interest := round(product * m,2)
               totint := interest + totint
               product := 0
            endif
            aadd(reportarr,{counter,balance,instal,balance + instal,interest,balance + instal + interest})
            balance := balance + interest + instal
            count1 := count1 + 1
            counter := counter + 1
            interest := 0.0
         enddo
      endif
      if counter <= (fulcomp / yearlycompoundings * yearlyinstalments)
         aadd(reportarr,{counter,balance,instal,balance + instal,interest,balance + instal + interest})
         balance := balance + interest + instal
         counter := counter + 1
         interest := 0.0
      endif
   enddo
   interest.recurdepositaccount.deleteallitems()
   interest.recurdepositaccount.header(1) := head1
   total1 := 0.0
   total2 := 0.0
   for i := 1 to len(reportarr)
      interest.recurdepositaccount.additem({alltrim(str(reportarr[i,1],5,0)),;
                                    alltrim(iif(reportarr[i,2] > 0,str(reportarr[i,2],14,2),"")),;
                                    alltrim(iif(reportarr[i,3] > 0,str(reportarr[i,3],14,2),"")),;
                                    alltrim(iif(reportarr[i,4] > 0,str(reportarr[i,4],14,2),"")),;
                                    alltrim(iif(reportarr[i,5] > 0,str(reportarr[i,5],14,2),"")),;
                                    alltrim(str(reportarr[i,6],14,2))})
      total1 := total1 + reportarr[i,3]
      total2 := total2 + reportarr[i,5]
   next i
   interest.rdtotalinvestment.value := total1
   interest.rdtotalinterest.value := total2
   interest.recurdepositaccount.value := 1
   interest.recurdepositaccount.setFocus()
   rdreportcreated := .t.
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings  // rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   head1 := interest.rdepositinterval.item(interest.rdepositintcomp.value)
   counter := 1
   count1 := 1
   instal1 := 0.0
   balance := 0.0
   totint := 0.0
   totinst := 0.0
   product := 0.0
   interest := 0.0
   comcount := 1
   inscount := 1
   do while counter <= period * yearlycompoundings/yearlyinstalments
      if inscount == n .or. counter == 1
         instal1 := instal
         totinst := totinst + instal1
         inscount := 0
      else
         instal1 := 0.0
      endif
      product := balance + product + instal1
      interest := round(product * m,2)
      totint := totint + interest
      product := 0.0
      aadd(reportarr,{counter,balance,instal1,balance + instal1,interest,balance + interest + instal1})
      balance := balance + interest + instal1
      counter := counter + 1
      inscount := inscount + 1
      interest := 0
   enddo
   interest.recurdepositaccount.deleteallitems()
   interest.recurdepositaccount.header(1) := head1
   total1 := 0.0
   total2 := 0.0
   for i := 1 to len(reportarr)
      interest.recurdepositaccount.additem({alltrim(str(reportarr[i,1],5,0)),;
                                    alltrim(iif(reportarr[i,2] > 0,str(reportarr[i,2],14,2),"")),;
                                    alltrim(iif(reportarr[i,3] > 0,str(reportarr[i,3],14,2),"")),;
                                    alltrim(iif(reportarr[i,4] > 0,str(reportarr[i,4],14,2),"")),;
                                    alltrim(iif(reportarr[i,5] > 0,str(reportarr[i,5],14,2),"")),;
                                    alltrim(str(reportarr[i,6],14,2))})
      total1 := total1 + reportarr[i,3]
      total2 := total2 + reportarr[i,5]
   next i
   interest.rdtotalinvestment.value := total1
   interest.rdtotalinterest.value := total2
   interest.recurdepositaccount.value := 1
   interest.recurdepositaccount.setFocus()
   rdreportcreated := .t.
endif
return nil

function recurdeposittextreport
local intarr2 := {360,12,4,2,1}
local instal := interest.rdinstalment.value
local intrate := interest.rdepositinterest.value / 100
local period := interest.rdepositperiod.value
local maturity := interest.rdepositmaturity.value
local yearlycompoundings := intarr2[interest.rdepositintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := intarr2[interest.rdepositinterval.value] // No. of instalements per annum
local reportarr := {}
LOCAL savefilename := putfile({{"Text Files","*.txt"}},"Report Save as")
IF len(alltrim(savefilename)) == 0
   RETURN nil
ENDIF
IF file(savefilename)
   IF .not. msgyesno("File Already exists. Do yo want to overwrite?","Save Report")
      RETURN nil
   ENDIF
ENDIF
IF interest.recurdepositaccount.itemcount == 0
   msgstop("No data to report!","Interest(ing) Calculator")
   RETURN nil
endif

if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   set conso off
   set alter to &savefilename
   set alter on
   head1 := interest.rdepositinterval.item(interest.rdepositinterval.value)
   counter := 1
   count1 := 1
   balance := 0.0
   totint := 0
   totinst := 0
   product := 0
   interest := 0
   ?"Instalment Amount      :"+str(instal,16,2)
   ?"Period of Investment :"+str(period,3,0)+" "+interest.rdepositinterval.item(interest.rdepositinterval.value)
   ?"Amount of Maturity  :"+str(maturity,14,2)
   ?"Interest Compounding  :"+" "+alltrim(interest.rdepositintcomp.item(interest.rdepositintcomp.value))
   ?"Interest Rate         :"+str(interest.rdepositinterest.value,6,2)+" % p.a."
   ?"----------------------------------------------------------------------------------------------------"
   ?head1 + space(10 - len(head1))+"  Opening Bal.   +    Investment  =          Total     +     Interest       =  Cl. Balance"
   ?"----------------------------------------------------------------------------------------------------"
   do while counter <= period
      product := product + balance + instal
      totinst := totinst + instal
      if mod(counter,yearlyinstalments/yearlycompoundings) == 0
         interest := round(product * m,2)
         totint := interest + totint
         product := 0.0
      endif
      if counter > (fulcomp / yearlycompoundings * yearlyinstalments)
         product := 0
         do while count1 <= balacomp
            product := product + balance + instal
            if counter == period
               interest := round(product * m,2)
               totint := interest + totint
               product := 0
            endif
            ? str(counter,5,0)+"   "+str(balance,14,2)+"         "+str(instal,10,2)+"       "+str(balance + instal)+"         "+str(interest,10,2)
            aadd(reportarr,{counter,balance,instal,balance + instal,interest,balance + instal + interest})
            balance := balance + interest + instal
            ??"       "+str(balance,12,2)
            count1 := count1 + 1
            counter := counter + 1
            interest := 0.0
         enddo
      endif
      if counter <= (fulcomp / yearlycompoundings * yearlyinstalments)
         ? str(counter,5,0)+"   "+str(balance,14,2)+"         "+str(instal,10,2)+"       "+str(balance + instal)+"    +    "+str(interest,10,2)
         aadd(reportarr,{counter,balance,instal,balance + instal,interest,balance + instal + interest})
         balance := balance + interest + instal
         ??"       "+str(balance,12,2)
         counter := counter + 1
         interest := 0.0
      endif
   enddo
   ?"----------------------------------------------------------------------------------------------------"
   ?"              Total            "+str(totinst,10,2)+"                             "+str(totint,10,2)
   ?"----------------------------------------------------------------------------------------------------"
   set alte off
   set alte to
   set conso on
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings  // rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   set conso off
   set alter to &savefilename
   set alter on
   head1 := interest.rdepositinterval.item(interest.rdepositintcomp.value)
   counter := 1
   count1 := 1
   instal1 := 0.0
   balance := 0.0
   totint := 0.0
   totinst := 0.0
   product := 0.0
   interest := 0.0
   ?"Instalment Amount      :"+str(instal,16,2)
   ?"Period of Investment :"+str(period,3,0)+" "+interest.rdepositinterval.item(interest.rdepositinterval.value)
   ?"Amount of Maturity  :"+str(maturity,14,2)
   ?"Interest Compounding  :"+" "+alltrim(interest.rdepositintcomp.item(interest.rdepositintcomp.value))
   ?"Interest Rate         :"+str(interest.rdepositinterest.value,6,2)+" % p.a."
   ?"----------------------------------------------------------------------------------------------------"
   ?head1 + space(10 - len(head1))+"  Opening Bal.   +    Investment  =          Total     +     Interest       =  Cl. Balance"
   ?"----------------------------------------------------------------------------------------------------"
   comcount := 1
   inscount := 1
   do while counter <= period * yearlycompoundings/yearlyinstalments
      if inscount == n .or. counter == 1
         instal1 := instal
         totinst := totinst + instal1
         inscount := 0
      else
         instal1 := 0.0
      endif
      product := balance + product + instal1
      interest := round(product * m,2)
      totint := totint + interest
      product := 0.0
      ? str(counter,5,0)+"   "+str(balance,14,2)+"         "+str(instal1,10,2)+"       "+str(balance + instal1)+"    +    "+str(interest,10,2)
      aadd(reportarr,{counter,balance,instal1,balance + instal1,interest,balance + interest + instal1})
      balance := balance + interest + instal1
      ??"       "+str(balance,12,2)
      counter := counter + 1
      inscount := inscount + 1
      interest := 0
   enddo
   ?"----------------------------------------------------------------------------------------------------"
   ?"              Total            "+str(totinst,10,2)+"                             "+str(totint,10,2)
   ?"----------------------------------------------------------------------------------------------------"
   set alte off
   set alte to
   set conso on
endif
execute file savefilename
return nil


function rdrepprint
&& local aHeaders := {"Deposit Instalment Amount: "+alltrim(str(interest.rdinstalment.value))+","+"Interest Rate: "+alltrim(str(interest.rdepositinterest.value))+"% ("+alltrim(interest.rdepositintcomp.item(interest.rdepositintcomp.value))+" Compunding)",;
                    && "Period :"+alltrim(str(interest.rdepositperiod.value))+" "+alltrim(interest.rdepositinterval.item(interest.rdepositinterval.value))+" Maturity Value : "+alltrim(str(interest.rdepositmaturity.value))}

&& print grid recurdepositaccount of interest headers aHeaders columnsum {{.f.,""},{.f.,""},{.t.,"99999999999.99"},{.f.,""},{.t.,"99999999999.99"},{.f.,""}}

return nil



function rdexportxl
local oExcel, oH
local reportarr := {}
local row := 5
if interest.recurdepositaccount.itemcount == 0
   msgstop("Nothing to export!","Error")
   return nil
endif
oExcel := TOleAuto():new( "Excel.Application" )
if Ole2TxtError() != "S_OK"
   MsgStop("Excel Not available.", "Error")
   return nil
endif
oExcel:WorkBooks:add()
oH := oExcel:Get( "ActiveSheet" )
oH:cells(row,1):value := "Instalment Amount :"
oH:cells(row,2):value := interest.rdinstalment.value  &&b5
row := row + 1
oH:cells(row,1):value := "Period of Investment :"
oH:cells(row,2):value := interest.rdepositperiod.value
oH:cells(row,3):value := interest.rdepositinterval.item(interest.rdepositinterval.value)
row := row + 1
oH:cells(row,1):value := "Maturity Amount :"
oH:cells(row,2):value := interest.rdepositmaturity.value
row := row + 1
oH:cells(row,1):value := "Interest Compounding  :"
oH:cells(row,2):value := alltrim(interest.rdepositintcomp.item(interest.rdepositintcomp.value))
row := row + 1
oH:cells(row,1):value := "Interest Rate:"
oH:cells(row,2):value := interest.rdepositinterest.value/100
oH:cells(row,2):set( "NumberFormat", "0.00%" )
oH:cells(row,3):value := "p.a."
row := row + 2
oH:cells(row,1):value := interest.recurdepositaccount.header(1)
oH:cells(row,2):value := interest.recurdepositaccount.header(2)
oH:cells(row,3):value := interest.recurdepositaccount.header(3)
oH:cells(row,4):value := interest.recurdepositaccount.header(4)
oH:cells(row,5):value := interest.recurdepositaccount.header(5)
oH:cells(row,6):value := interest.recurdepositaccount.header(6)
row := row + 1
frow := row
for i := 1 to interest.recurdepositaccount.itemcount
   if i == 1
      oH:cells(row,1):value := i
      oH:cells(row,2):value := 0.0
      oH:cells(row,2):set ("NumberFormat","##########0.00")
   else
      oH:cells(row,1):value := i
      oH:cells(row,2):value := "=f"+alltrim(str(row-1,5,0))
      oH:cells(row,2):set ("NumberFormat","##########0.00")
   endif
   templine := interest.recurdepositaccount.item(i)
   oH:cells(row,2):value := val(alltrim(templine[2]))
   oH:cells(row,2):set ("NumberFormat","##########0.00")
   oH:cells(row,3):value := val(alltrim(templine[3]))
   oH:cells(row,3):set ("NumberFormat","##########0.00")
   oH:cells(row,4):value := "=b"+alltrim(str(row,5,0))+"+c"+alltrim(str(row,5,0))
   oH:cells(row,4):set ("NumberFormat","##########0.00")
   oH:cells(row,5):value := val(alltrim(templine[5]))
   oH:cells(row,5):set ("NumberFormat","##########0.00")
   oH:cells(row,6):value := "=d"+alltrim(str(row,5,0))+"+e"+alltrim(str(row,5,0))
   oH:cells(row,6):set ("NumberFormat","##########0.00")
   row := row + 1
next i
oH:cells(row,3):value := "=sum(c"+alltrim(str(frow,5,0))+":c"+alltrim(str(row-1,5,0))
oH:cells(row,3):set ("NumberFormat","##########0.00")
oH:cells(row,5):value := "=sum(e"+alltrim(str(frow,5,0))+":e"+alltrim(str(row-1,5,0))
oH:cells(row,5):set ("NumberFormat","##########0.00")
oH:cells(1,1):select()
oExcel:visible := .T.
oH:end()
oExcel:end()
return nil
