#include "hmg.ch"

declare window interest
function rprincipalcalculate
local prin := 0.0
local intrate := iif(interest.resaccount.value == 1,interest.rtintrate.value / 100,interest.buyrate.value / 100)
local period := interest.rtterm.value
local instal := interest.rtinstalment.value
local yearlycompoundings := intarr1[interest.rcintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := repayarr1[interest.rcterm.value] // No. of instalements per annum
local m := 0.0
LOCAL fulcomp := 0.0
LOCAL balacomp := 0.0
LOCAL total1 := 0.0
LOCAL x := 0.0
LOCAL l := 0.0
if intrate == 0.0 .or. instal == 0.0 .or. period == 0.0
   msginfo("You have to enter Interest Rate, Instalment Amount and Term of the Loan to find out the Principal.","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   total1 := 0.0
   x := yearlyinstalments / yearlycompoundings
   l := (x + (x * (x - 1) / 2 * m))/(1+(intrate / yearlycompoundings))
   if balacomp > 0
      m1 := (balacomp+((balacomp*(balacomp-1)/2)*m))/(1+(m*balacomp))/(1+(intrate/yearlycompoundings))^fulcomp
      total1 := total1 + m1
   endif
   if fulcomp > 0
      total1 := total1 + l
   endif
   for i := 2 to fulcomp
       l := l / (1+(intrate / yearlycompoundings))
       total1 := total1 + l
   next i

   prin := total1 * instal
   interest.rtprincipal.value := prin
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings// rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   counter := 1
   l := 1
   total1 := 0.0
   do while counter <= period
      l := l/((1+m)^n)
      total1 := total1 + l
      counter := counter + 1
   enddo
   prin := total1 * instal
   interest.rtprincipal.value := prin
ENDIF
interest.rtinstalment.fontcolor := {0,0,0}
interest.rtprincipal.fontcolor := {255,0,0}
interest.rtterm.fontcolor := {0,0,0}
interest.rtintrate.fontcolor := {0,0,0}
interest.rloanresult.value := "Principal :"+alltrim(str(interest.rtprincipal.value,14,2))
rshowloanaccount()
reservecalculate()
return nil

function rintratecalculate
local prin := interest.rtprincipal.value
local intrate := 0.0
local period := interest.rtterm.value
local instal := interest.rtinstalment.value
local yearlycompoundings := intarr1[interest.rcintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := repayarr1[interest.rcterm.value] // No. of instalements per annum
local m := 0.0
if prin == 0.0 .or. instal == 0.0 .or. period == 0.0
   msginfo("You have to enter Principal Amount, Instalment Amount and Term of the Loan to find out the Interest Rate.","Interest(ing) Calculator")
   return nil
endif
if interest.rtterm.value * interest.rtinstalment.value < interest.rtprincipal.value
   msginfo("The total instalments payable can not be below the principal value!!!","Interest(ing) Calculator")
   interest.rtinstalment.setFocus()
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   intrate := 0.00001
   crossed := .f.
   interest.statusBar.item(1) := "Please Wait while calculating the interest rate."
   centpercentwarn := .f.
   do while .not. crossed
      total1 := 0.0
      m := intrate / yearlyinstalments// rate per yearlyinstalments
      x := yearlyinstalments / yearlycompoundings
      l := (x + (x * (x - 1) / 2 * m))/(1+(intrate / yearlycompoundings))
      if balacomp > 0
         m1 := (balacomp+((balacomp*(balacomp-1)/2)*m))/(1+(m*balacomp))/(1+(intrate/yearlycompoundings))^fulcomp
         total1 := total1 + m1
      endif
      if fulcomp > 0
         total1 := total1 + l
      endif
      for i := 2 to fulcomp
          l := l / (1+(intrate / yearlycompoundings))
          total1 := total1 + l
      next i
      if (total1*instal)- prin  < 0.0
         crossed := .t.
         if centpercentwarn
            interest.statusBar.item(1) := "Caution. Interest Rate goes beyond 100%! "+str(intrate*100,9,4)
         else
            interest.statusBar.item(1) := ""
         endif
      else
         if ((total1*instal)-prin)/prin > 0.01
            intrate := intrate + 0.0001
         else
            intrate := intrate + 0.00001
         endif
         if intrate > 1 .and. .not. centpercentwarn
            interest.statusBar.item(1) := "Caution. Interest Rate goes beyond 100%!"
            centpercentwarn := .t.
         endif
      endif
   enddo
   if interest.resaccount.value == 1
      interest.rtintrate.value := intrate * 100
   else 
      interest.buyrate.value := intrate * 100
   endif
endif
if yearlyinstalments < yearlycompoundings
   n := (yearlycompoundings/yearlyinstalments)
   intrate := 0.00001
   crossed := .f.
   centpercentwarn := .f.
   interest.statusBar.item(1) := "Please Wait while calculating the interest rate."
   do while .not. crossed
      counter := 1
      l := 1
      m := intrate / yearlycompoundings// rate per compounding period
      total1 := 0.0
      do while counter <= period
         l := l/((1+m)^n)
         total1 := total1 + l
         counter := counter + 1
      enddo
      if (total1*instal)- prin  < 0.0
         crossed := .t.
         if centpercentwarn
            interest.statusBar.item(1) := "Caution. Interest Rate goes beyond 100%! "+str(intrate*100,9,4)
         else
            interest.statusBar.item(1) := ""
         endif
      else
         if ((total1*instal)-prin)/prin > 0.01
            intrate := intrate + 0.0001
         else
            intrate := intrate + 0.00001
         endif
         if intrate > 1 .and. .not. centpercentwarn
            interest.statusBar.item(1) := "Caution. Interest Rate goes beyond 100%!"
            centpercentwarn := .t.
         endif
      endif
   enddo
   if interest.resaccount.value == 1
      interest.rtintrate.value := intrate * 100
   else 
      interest.buyrate.value := intrate * 100
   endif
ENDIF
interest.rtinstalment.fontcolor := {0,0,0}
interest.rtprincipal.fontcolor := {0,0,0}
interest.rtterm.fontcolor := {0,0,0}
interest.rtintrate.fontcolor := {255,0,0}
interest.rloanresult.value := "Interest Rate :"+alltrim(str(interest.rtintrate.value,6,2))+"% p.a."
rshowloanaccount()
reservecalculate()
return nil



function rtermcalculate
local prin := interest.rtprincipal.value
local intrate := iif(interest.resaccount.value == 1,interest.rtintrate.value / 100,interest.buyrate.value / 100)
local period := 0
local instal := interest.rtinstalment.value
local yearlycompoundings := intarr1[interest.rcintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := repayarr1[interest.rcterm.value] // No. of instalements per annum
local m := 0.0
if intrate == 0.0 .or. instal == 0.0 .or. prin == 0.0
   msginfo("You have to enter Interest Rate, Instalment Amount and Principal of the Loan to find out the Term of the Loan.","Interest(ing) Calculator")
   return nil
endif
if prin < instal
   msginfo("Principal amount must be greater than Instalment amount.","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   if (prin * m) >= instal
      msginfo("The instalment amount is not enough even to cover the interest portion!","Interest(ing) Calculator")
      interest.rtinstalment.setFocus()
      return nil
   endif
   period := prin / instal
   crossed := .f.
   x := yearlyinstalments / yearlycompoundings
   interest.statusBar.item(1) := "Please Wait while calculating the number of instalments."
   do while .not. crossed
      l := (x + (x * (x - 1) / 2 * m))/(1+(intrate / yearlycompoundings))
      fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
      balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
      total1 := 0.0
      if balacomp > 0
         m1 := (balacomp+((balacomp*(balacomp-1)/2)*m))/(1+(m*balacomp))/(1+(intrate/yearlycompoundings))^fulcomp
         total1 := total1 + m1
      endif
      if fulcomp > 0
         total1 := total1 + l
      endif
      for i := 2 to fulcomp
          l := l / (1+(intrate / yearlycompoundings))
          total1 := total1 + l
      next i
      if (total1*instal)- prin  > 0.0
         crossed := .t.
         interest.statusBar.item(1) := ""
      else
         period := period + 1
      endif
   enddo
   interest.rtterm.value := round(period,0)
endif
if yearlyinstalments < yearlycompoundings
   n := (yearlycompoundings/yearlyinstalments)
   m := intrate / yearlycompoundings// rate per compounding period
   interest := 0.0
   balance := prin
   for i := 1 to n
      interest := interest + (balance * m)
      balance := prin + interest
   next i
   if instal <= interest
      msginfo("The instalment amount is not enough even to cover the interest portion!","Interest(ing) Calculator")
      interest.rtinstalment.setFocus()
      return nil
   endif
   period := prin / instal
   crossed := .f.
   interest.statusBar.item(1) := "Please Wait while calculating the number of instalments."
   do while .not. crossed
      counter := 1
      l := 1
      total1 := 0.0
      do while counter <= period
         l := l/((1+m)^n)
         total1 := total1 + l
         counter := counter + 1
      enddo
      if (total1*instal)- prin  > 0.0
         crossed := .t.
         interest.statusBar.item(1) := ""
      else
         period := period + 1
      endif
   enddo
   interest.rtterm.value := round(period,0)
ENDIF
interest.rtinstalment.fontcolor := {0,0,0}
interest.rtprincipal.fontcolor := {0,0,0}
interest.rtterm.fontcolor := {255,0,0}
interest.rtintrate.fontcolor := {0,0,0}
interest.rloanresult.value := "Term :"+alltrim(str(interest.rtterm.value,14,0))
rshowloanaccount()
reservecalculate()
return nil

function rinstalmentcalculate
local prin := interest.rtprincipal.value
local intrate := iif(interest.resaccount.value == 1,interest.rtintrate.value / 100,interest.buyrate.value / 100)
local period := interest.rtterm.value
local instalments := 0.0
local yearlycompoundings := intarr1[interest.rcintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := repayarr1[interest.rcterm.value] // No. of instalements per annum
local m := 0.0
if intrate == 0.0 .or. prin == 0.0 .or. period == 0.0
   msginfo("You have to enter Principal Amount, Interest Rate, Instalment Amount to find out the Instalment Amount.","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   total1 := 0.0
   x := yearlyinstalments / yearlycompoundings
   l := (x + (x * (x - 1) / 2 * m))/(1+(intrate / yearlycompoundings))
   if balacomp > 0
      m1 := (balacomp+((balacomp*(balacomp-1)/2)*m))/(1+(m*balacomp))/(1+(intrate/yearlycompoundings))^fulcomp
      total1 := total1 + m1
   endif
   if fulcomp > 0
      total1 := total1 + l
   endif
   for i := 2 to fulcomp
       l := l / (1+(intrate / yearlycompoundings))
       total1 := total1 + l
   next i

   instal := prin / total1
   interest.rtinstalment.value := instal
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings// rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   counter := 1
   l := 1
   total1 := 0.0
   do while counter <= period
      l := l/((1+m)^n)
      total1 := total1 + l
      counter := counter + 1
   enddo
   instal := prin / total1
   interest.rtinstalment.value := instal
ENDIF
interest.rtinstalment.fontcolor := {255,0,0}
interest.rtprincipal.fontcolor := {0,0,0}
interest.rtterm.fontcolor := {0,0,0}
interest.rtintrate.fontcolor := {0,0,0}
interest.rloanresult.value := "Instalment :"+alltrim(str(interest.rtinstalment.value,14,2))
rshowloanaccount()
reservecalculate()
return nil

function rshowloanaccount
local prin := interest.rtprincipal.value
local intrate := interest.rtintrate.value / 100
local period := interest.rtterm.value
LOCAL roundby := 2
local instal := interest.rtinstalment.value
local yearlycompoundings := intarr1[interest.rcintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := repayarr1[interest.rcterm.value] // No. of instalements per annum
LOCAL total1 := 0.0
LOCAL total2 := 0.0
local reportarr := {}
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   head1 := substr(termarr[interest.rcterm.value],1,len(termarr[interest.rcterm.value]) - 1)
   counter := 1
   count1 := 1
   balance := prin
   totint := 0
   totinst := 0
   product := 0
   interest := 0
   do while counter <= period
      totinst := totinst + instal
      product := product + balance
      if mod(counter,yearlyinstalments/yearlycompoundings) == 0
         interest := round(product * m,roundby)
         totint := interest + totint
         product := 0.0
      endif
      if counter > (fulcomp / yearlycompoundings * yearlyinstalments)
         product := 0
         totinst := totinst - instal
         do while count1 <= balacomp
            totinst := totinst + instal
            product := product + balance
            if counter == period
               interest := round(product * m,roundby)
               totint := interest + totint
               product := 0
            endif
            aadd(reportarr,{counter,balance,interest,instal,balance + interest - instal})
            balance := balance + interest - instal
            count1 := count1 + 1
            counter := counter + 1
            interest := 0
         enddo
      endif
      if counter <= (fulcomp / yearlycompoundings * yearlyinstalments)
         aadd(reportarr,{counter,balance,interest,instal,balance + interest - instal})
         balance := balance + interest - instal
         counter := counter + 1
         interest := 0
      endif
   enddo
   interest.rloanaccount.deleteallitems()
   interest.rloanaccount.header(1) := head1
   total1 := 0.0
   total2 := 0.0
   for i := 1 to len(reportarr)
      interest.rloanaccount.additem({alltrim(str(reportarr[i,1],5,0)),;
                                    alltrim(iif(reportarr[i,2] > 0,str(reportarr[i,2],14,2),"")),;
                                    alltrim(iif(reportarr[i,3] > 0,str(reportarr[i,3],14,2),"")),;
                                    alltrim(iif(reportarr[i,4] > 0,str(reportarr[i,4],14,2),"")),;
                                    alltrim(str(reportarr[i,5],14,2))})
      total1 := total1 + reportarr[i,3]
      total2 := total2 + reportarr[i,4]
   next i
   interest.rtotalinterest.value := total1
   interest.rtotalrepayment.value := total2
   interest.rloanaccount.value := 1
   interest.rloanaccount.setFocus()
   loanreportcreated := .t.
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings  // rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   head1 := substr(termarr[interest.rcintcomp.value],1,len(termarr[interest.rcintcomp.value]) - 1)
   counter := 1
   count1 := 1
   instal1 := 0.0
   balance := prin
   totint := 0.0
   totinst := 0.0
   product := 0.0
   interest := 0.0
   comcount := 1
   inscount := 1
   do while counter <= period * yearlycompoundings/yearlyinstalments
      product := balance + product
      interest := round(product * m,roundby)
      totint := totint + interest
      product := 0.0
      if inscount == n
         instal1 := instal
         totinst := totinst + instal1
         inscount := 0
      else
         instal1 := 0
      endif
      aadd(reportarr,{counter,balance,interest,instal1,balance + interest - instal1})
      balance := balance + interest - instal1
      counter := counter + 1
      inscount := inscount + 1
      interest := 0
   enddo
   interest.rloanaccount.deleteallitems()
   interest.rloanaccount.header(1) := head1
   total1 := 0.0
   total2 := 0.0
   for i := 1 to len(reportarr)
      interest.rloanaccount.additem({alltrim(str(reportarr[i,1],5,0)),;
                                    alltrim(iif(reportarr[i,2] > 0,str(reportarr[i,2],14,2),"")),;
                                    alltrim(iif(reportarr[i,3] > 0,str(reportarr[i,3],14,2),"")),;
                                    alltrim(iif(reportarr[i,4] > 0,str(reportarr[i,4],14,2),"")),;
                                    alltrim(str(reportarr[i,5],14,2))})
      total1 := total1 + reportarr[i,3]
      total2 := total2 + reportarr[i,4]
   next i
   interest.rtotalinterest.value := total1
   interest.rtotalrepayment.value := total2
   interest.rloanaccount.value := 1
   interest.rloanaccount.setFocus()
   loanreportcreated := .t.
endif
return nil


function rinterestreport
local prin := interest.rtprincipal.value
local intrate := interest.rtintrate.value / 100
local period := interest.rtterm.value
local instal := interest.rtinstalment.value
LOCAL roundby := 2
local yearlycompoundings := intarr1[interest.rcintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := repayarr1[interest.rcterm.value] // No. of instalements per annum
local reportarr := {}
LOCAL savefilename := putfile({{"Text Files","*.txt"}},"Report Save as")
IF len(alltrim(savefilename)) == 0
   RETURN nil
ENDIF
IF file(savefilename)
   IF .not. msgyesno("File Already exists. Do yo want to overwrite?","Save Report")
      RETURN nil
   ENDIF
ENDIF
IF interest.rloanaccount.itemcount == 0
   msgstop("No data to report!","Interest(ing) Calculator")
   RETURN nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   set conso off
   set alter to &savefilename
   set alter on
   head1 := substr(termarr[interest.rcterm.value],1,len(termarr[interest.rcterm.value]) - 1)
   counter := 1
   count1 := 1
   balance := prin
   totint := 0
   totinst := 0
   product := 0
   interest := 0
   ?"Principal Amount      :"+str(balance,16,roundby)
   ?"Number of "+alltrim(intarr[interest.rcterm.value])+ " Instalments :"+str(period,5,0)
   ?"Amount of Instalment  :"+str(instal,14,roundby)
   ?"Interest Compounding  :"+" "+alltrim(interest.rcintcomp.item(interest.rcintcomp.value))
   ?"Interest Rate         :"+str(interest.rtintrate.value,10,roundby)+" % p.a."
   ?"------------------------------------------------------------------------------"
   ?head1+space(10-len(head1))+"   Principal     +     Interest    -   Inst. Amount    = Closing Bal."
   ?"------------------------------------------------------------------------------"
   do while counter <= period
      totinst := totinst + instal
      product := product + balance
      if mod(counter,yearlyinstalments/yearlycompoundings) == 0
         interest := round(product * m,roundby)
         totint := interest + totint
         product := 0.0
      endif
      if counter > (fulcomp / yearlycompoundings * yearlyinstalments)
         product := 0
         totinst := totinst - instal
         do while count1 <= balacomp
            totinst := totinst + instal
            product := product + balance
            if counter == period
               interest := round(product * m,roundby)
               totint := interest + totint
               product := 0
            endif
            ? str(counter,5,0)+"   "+str(balance,14,roundby)+"         "+str(interest,10,roundby)+"        "+str(instal,10,roundby)
            aadd(reportarr,{counter,balance,interest,instal,balance + interest - instal})
            balance := balance + interest - instal
            ??"       "+str(balance,12,roundby)
            count1 := count1 + 1
            counter := counter + 1
            interest := 0
         enddo
      endif
      if counter <= (fulcomp / yearlycompoundings * yearlyinstalments)
         ? str(counter,5,0)+"   "+str(balance,14,roundby)+"         "+str(interest,10,roundby)+"        "+str(instal,10,roundby)
         aadd(reportarr,{counter,balance,interest,instal,balance + interest - instal})
         balance := balance + interest - instal
         ??"       "+str(balance,12,roundby)
         counter := counter + 1
         interest := 0
      endif
   enddo
   ?"------------------------------------------------------------------------------"
   ?"              Total            "+str(totint,10,roundby)+"        "+str(totinst,10,roundby)
   ?"------------------------------------------------------------------------------"
   set alte off
   set alte to
   set conso on
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings  // rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   set conso off
   set alter to &savefilename
   set alter on
   head1 := substr(termarr[interest.rcintcomp.value],1,len(termarr[interest.rcintcomp.value]) - 1)
   counter := 1
   count1 := 1
   instal1 := 0.0
   balance := prin
   totint := 0.0
   totinst := 0.0
   product := 0.0
   interest := 0.0
   ?"Principal Amount      :"+str(balance,16,2)
   ?"Number of "+alltrim(intarr[interest.rcterm.value])+ " Instalments :"+str(period,5,0)
   ?"Amount of Instalment  :"+str(instal,14,2)
   ?"Interest Compounding  :"+" "+alltrim(interest.rcintcomp.item(interest.rcintcomp.value))
   ?"Interest Rate         :"+str(interest.rtintrate.value,6,2)+" % p.a."
   ?"------------------------------------------------------------------------------"
   ?head1 + space(10 - len(head1))+"   Principal     +     Interest    -   Inst. Amount    = Closing Bal."
   ?"------------------------------------------------------------------------------"
   comcount := 1
   inscount := 1
   do while counter <= period * yearlycompoundings/yearlyinstalments
      product := balance + product
      interest := round(product * m,2)
      totint := totint + interest
      product := 0.0
      if inscount == n
         instal1 := instal
         totinst := totinst + instal1
         inscount := 0
      else
         instal1 := 0
      endif
      ? str(counter,5,0)+"   "+str(balance,14,2)+"         "+str(interest,10,2)+"        "+str(instal1,10,2)
      aadd(reportarr,{counter,balance,interest,instal1,balance + interest - instal1})
      balance := balance + interest - instal1
      ??"       "+str(balance,12,2)
      counter := counter + 1
      inscount := inscount + 1
      interest := 0
   enddo
   ?"------------------------------------------------------------------------------"
   ?"              Total            "+str(totint,10,2)+"        "+str(totinst,10,2)
   ?"------------------------------------------------------------------------------"
   set alte off
   set alte to
   set conso on
endif
&& execute file savefilename
return nil


function rloanrepprint

return nil

function rloanexportxl
local oExcel, oH
local reportarr := {}
local row := 5
if interest.rloanaccount.itemcount == 0
   msgstop("Nothing to export!","Error")
   return nil
endif
oExcel := TOleAuto():new( "Excel.Application" )
if Ole2TxtError() != "S_OK"
   MsgStop("Excel Not available.", "Error")
   return nil
endif
oExcel:WorkBooks:add()
oH := oExcel:Get( "ActiveSheet" )
oH:cells(row,1):value := "Principal Amount :"
oH:cells(row,2):value := interest.rtprincipal.value  &&b5
row := row + 1
oH:cells(row,1):value := "Number of "+alltrim(intarr[interest.rcterm.value])+ " Instalments :"
oH:cells(row,2):value := interest.rtterm.value  &&b6
row := row + 1
oH:cells(row,1):value := "Amount of Instalment :"
oH:cells(row,2):value := interest.rtinstalment.value &&b7
row := row + 1
oH:cells(row,1):value := "Interest Compounding  :"
oH:cells(row,2):value := alltrim(interest.rcintcomp.item(interest.rcintcomp.value)) &&b8
row := row + 1
oH:cells(row,1):value := "Interest Rate:"
oH:cells(row,2):value := interest.rtintrate.value/100 &&b9
oH:cells(row,2):set( "NumberFormat", "0.00%" )
oH:cells(row,3):value := "p.a."
row := row + 2
oH:cells(row,1):value := interest.rloanaccount.header(1)
oH:cells(row,2):value := interest.rloanaccount.header(2)
oH:cells(row,3):value := interest.rloanaccount.header(3)
oH:cells(row,4):value := interest.rloanaccount.header(4)
oH:cells(row,5):value := interest.rloanaccount.header(5)
row := row + 1
frow := row
for i := 1 to interest.rloanaccount.itemcount
   if i == 1
      oH:cells(row,1):value := i
      oH:cells(row,2):value := "=$b$5"
      oH:cells(row,2):set ("NumberFormat","##########0.00")
   else
      oH:cells(row,1):value := i
      oH:cells(row,2):value := "=e"+alltrim(str(row-1,5,0))
      oH:cells(row,2):set ("NumberFormat","##########0.00")
   endif
   templine := interest.rloanaccount.item(i)
   oH:cells(row,3):value := val(alltrim(templine[3]))
   oH:cells(row,3):set ("NumberFormat","##########0.00")
   oH:cells(row,4):value := val(alltrim(templine[4]))
   oH:cells(row,4):set ("NumberFormat","##########0.00")
   oH:cells(row,5):value := "=b"+alltrim(str(row,5,0))+"+c"+alltrim(str(row,5,0))+"-d"+alltrim(str(row,5,0))
   oH:cells(row,5):set ("NumberFormat","##########0.00")
   row := row + 1
next i
oH:cells(row,3):value := "=sum(c"+alltrim(str(frow,5,0))+":c"+alltrim(str(row-1,5,0))
oH:cells(row,3):set ("NumberFormat","##########0.00")
oH:cells(row,4):value := "=sum(d"+alltrim(str(frow,5,0))+":d"+alltrim(str(row-1,5,0))
oH:cells(row,4):set ("NumberFormat","##########0.00")
oH:cells(1,1):select()
oExcel:visible := .T.
oH:end()
oExcel:end()
return nil


FUNCTION rloanreview
DO CASE
   CASE interest.rtprincipal.value == 0.0
      rprincipalcalculate()
   CASE interest.rtintrate.value == 0.0
      rintratecalculate()
   CASE interest.rtterm.value == 0.0
      rtermcalculate()
   CASE interest.rtinstalment.value == 0.0
      rinstalmentcalculate()
ENDCASE
RETURN nil


FUNCTION reservecalculate
local prin := interest.rtprincipal.value
local intrate := interest.buyrate.value / 100
local period := interest.rtterm.value
local instalments := 0.0
local yearlycompoundings := intarr1[interest.rcintcomp.value] // No. of interest compounding per annum
local yearlyinstalments := repayarr1[interest.rcterm.value] // No. of instalements per annum
local m := 0.0
local inst1 := 0.0
local inst2 := 0.0
if intrate == 0.0 .or. prin == 0.0 .or. period == 0.0
   msginfo("You have to enter Principal Amount, Interest Rate, Instalment Amount to find out the Instalment Amount.","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   total1 := 0.0
   x := yearlyinstalments / yearlycompoundings
   l := (x + (x * (x - 1) / 2 * m))/(1+(intrate / yearlycompoundings))
   if balacomp > 0
      m1 := (balacomp+((balacomp*(balacomp-1)/2)*m))/(1+(m*balacomp))/(1+(intrate/yearlycompoundings))^fulcomp
      total1 := total1 + m1
   endif
   if fulcomp > 0
      total1 := total1 + l
   endif
   for i := 2 to fulcomp
       l := l / (1+(intrate / yearlycompoundings))
       total1 := total1 + l
   next i

   instal := prin / total1
   inst1 := instal
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings// rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   counter := 1
   l := 1
   total1 := 0.0
   do while counter <= period
      l := l/((1+m)^n)
      total1 := total1 + l
      counter := counter + 1
   enddo
   instal := prin / total1
   inst1 := instal
ENDIF
intrate := interest.rtintrate.value / 100
prin := interest.rtprincipal.value
period := interest.rtterm.value
instalments := 0.0
yearlycompoundings := intarr1[interest.rcintcomp.value] // No. of interest compounding per annum
yearlyinstalments := repayarr1[interest.rcterm.value] // No. of instalements per annum
m := 0.0
inst2 := 0.0
if intrate == 0.0 .or. prin == 0.0 .or. period == 0.0
   msginfo("You have to enter Principal Amount, Interest Rate, Instalment Amount to find out the Instalment Amount.","Interest(ing) Calculator")
   return nil
endif
if yearlyinstalments >= yearlycompoundings
   m := intrate / yearlyinstalments// rate per yearlyinstalments
   fulcomp := int(period / (yearlyinstalments / yearlycompoundings)) //Full Compounding Period
   balacomp := period - (fulcomp / yearlycompoundings * yearlyinstalments) // Balance Compounding Period
   total1 := 0.0
   x := yearlyinstalments / yearlycompoundings
   l := (x + (x * (x - 1) / 2 * m))/(1+(intrate / yearlycompoundings))
   if balacomp > 0
      m1 := (balacomp+((balacomp*(balacomp-1)/2)*m))/(1+(m*balacomp))/(1+(intrate/yearlycompoundings))^fulcomp
      total1 := total1 + m1
   endif
   if fulcomp > 0
      total1 := total1 + l
   endif
   for i := 2 to fulcomp
       l := l / (1+(intrate / yearlycompoundings))
       total1 := total1 + l
   next i

   instal := prin / total1
   inst2 := instal
endif
if yearlyinstalments < yearlycompoundings
   m := intrate / yearlycompoundings// rate per compounding period
   n := (yearlycompoundings/yearlyinstalments)
   counter := 1
   l := 1
   total1 := 0.0
   do while counter <= period
      l := l/((1+m)^n)
      total1 := total1 + l
      counter := counter + 1
   enddo
   instal := prin / total1
   inst2 := instal
ENDIF
interest.reserve.value := (inst2 - inst1) * interest.rtterm.value
return nil